package com.mysql.jdbc;

import com.mysql.jdbc.profiler.ProfileEventSink;
import com.mysql.jdbc.profiler.ProfilerEvent;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.Reader;
import java.io.StringReader;
import java.io.UnsupportedEncodingException;
import java.lang.reflect.Constructor;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.net.MalformedURLException;
import java.net.URL;
import java.sql.Array;
import java.sql.Date;
import java.sql.Ref;
import java.sql.SQLException;
import java.sql.SQLWarning;
import java.sql.Time;
import java.sql.Timestamp;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import java.util.StringTokenizer;
import java.util.TimeZone;
import java.util.TreeMap;

/* loaded from: com_mysql_jdbc.jar:com/mysql/jdbc/ResultSetImpl.class */
public class ResultSetImpl implements ResultSetInternalMethods {
    private static final Constructor JDBC_4_RS_4_ARG_CTOR;
    private static final Constructor JDBC_4_RS_6_ARG_CTOR;
    private static final Constructor JDBC_4_UPD_RS_6_ARG_CTOR;
    protected static final double MIN_DIFF_PREC;
    protected static final double MAX_DIFF_PREC;
    protected static int resultCounter;
    protected String catalog;
    protected Map columnNameToIndex;
    protected boolean[] columnUsed;
    protected ConnectionImpl connection;
    protected long connectionId;
    protected int currentRow;
    TimeZone defaultTimeZone;
    protected boolean doingUpdates;
    protected ProfileEventSink eventSink;
    Calendar fastDateCal;
    protected int fetchDirection;
    protected int fetchSize;
    protected Field[] fields;
    protected char firstCharOfQuery;
    protected Map fullColumnNameToIndex;
    protected boolean hasBuiltIndexMapping;
    protected boolean isBinaryEncoded;
    protected boolean isClosed;
    protected ResultSetInternalMethods nextResultSet;
    protected boolean onInsertRow;
    protected StatementImpl owningStatement;
    protected Throwable pointOfOrigin;
    protected boolean profileSql;
    protected boolean reallyResult;
    protected int resultId;
    protected int resultSetConcurrency;
    protected int resultSetType;
    protected RowData rowData;
    protected String serverInfo;
    PreparedStatement statementUsedForFetchingRows;
    protected ResultSetRow thisRow;
    protected long updateCount;
    protected long updateId;
    private boolean useStrictFloatingPoint;
    protected boolean useUsageAdvisor;
    protected SQLWarning warningChain;
    protected boolean wasNullFlag;
    protected java.sql.Statement wrapperStatement;
    protected boolean retainOwningStatement;
    protected Calendar gmtCalendar;
    protected boolean useFastDateParsing;
    private boolean padCharsWithSpace;
    protected static final char[] EMPTY_SPACE;
    static Class class$com$mysql$jdbc$ConnectionImpl;
    static Class class$com$mysql$jdbc$StatementImpl;
    static Class class$java$lang$String;
    static Class array$Lcom$mysql$jdbc$Field;
    static Class class$com$mysql$jdbc$RowData;

    static {
        Class<?> cls;
        Class<?> cls2;
        Class<?> cls3;
        Class<?> cls4;
        Class<?> cls5;
        Class<?> cls6;
        Class<?> cls7;
        Class<?> cls8;
        Class<?> cls9;
        Class<?> cls10;
        Class<?> cls11;
        Class<?> cls12;
        if (Util.isJdbc4()) {
            try {
                Class<?> cls13 = Class.forName("com.mysql.jdbc.JDBC4ResultSet");
                Class<?>[] clsArr = new Class[4];
                clsArr[0] = Long.TYPE;
                clsArr[1] = Long.TYPE;
                if (class$com$mysql$jdbc$ConnectionImpl == null) {
                    cls = class$("com.mysql.jdbc.ConnectionImpl");
                    class$com$mysql$jdbc$ConnectionImpl = cls;
                } else {
                    cls = class$com$mysql$jdbc$ConnectionImpl;
                }
                clsArr[2] = cls;
                if (class$com$mysql$jdbc$StatementImpl == null) {
                    cls2 = class$("com.mysql.jdbc.StatementImpl");
                    class$com$mysql$jdbc$StatementImpl = cls2;
                } else {
                    cls2 = class$com$mysql$jdbc$StatementImpl;
                }
                clsArr[3] = cls2;
                JDBC_4_RS_4_ARG_CTOR = cls13.getConstructor(clsArr);
                Class<?> cls14 = Class.forName("com.mysql.jdbc.JDBC4ResultSet");
                Class<?>[] clsArr2 = new Class[5];
                if (class$java$lang$String == null) {
                    cls3 = class$("java.lang.String");
                    class$java$lang$String = cls3;
                } else {
                    cls3 = class$java$lang$String;
                }
                clsArr2[0] = cls3;
                if (array$Lcom$mysql$jdbc$Field == null) {
                    cls4 = class$("[Lcom.mysql.jdbc.Field;");
                    array$Lcom$mysql$jdbc$Field = cls4;
                } else {
                    cls4 = array$Lcom$mysql$jdbc$Field;
                }
                clsArr2[1] = cls4;
                if (class$com$mysql$jdbc$RowData == null) {
                    cls5 = class$("com.mysql.jdbc.RowData");
                    class$com$mysql$jdbc$RowData = cls5;
                } else {
                    cls5 = class$com$mysql$jdbc$RowData;
                }
                clsArr2[2] = cls5;
                if (class$com$mysql$jdbc$ConnectionImpl == null) {
                    cls6 = class$("com.mysql.jdbc.ConnectionImpl");
                    class$com$mysql$jdbc$ConnectionImpl = cls6;
                } else {
                    cls6 = class$com$mysql$jdbc$ConnectionImpl;
                }
                clsArr2[3] = cls6;
                if (class$com$mysql$jdbc$StatementImpl == null) {
                    cls7 = class$("com.mysql.jdbc.StatementImpl");
                    class$com$mysql$jdbc$StatementImpl = cls7;
                } else {
                    cls7 = class$com$mysql$jdbc$StatementImpl;
                }
                clsArr2[4] = cls7;
                JDBC_4_RS_6_ARG_CTOR = cls14.getConstructor(clsArr2);
                Class<?> cls15 = Class.forName("com.mysql.jdbc.JDBC4UpdatableResultSet");
                Class<?>[] clsArr3 = new Class[5];
                if (class$java$lang$String == null) {
                    cls8 = class$("java.lang.String");
                    class$java$lang$String = cls8;
                } else {
                    cls8 = class$java$lang$String;
                }
                clsArr3[0] = cls8;
                if (array$Lcom$mysql$jdbc$Field == null) {
                    cls9 = class$("[Lcom.mysql.jdbc.Field;");
                    array$Lcom$mysql$jdbc$Field = cls9;
                } else {
                    cls9 = array$Lcom$mysql$jdbc$Field;
                }
                clsArr3[1] = cls9;
                if (class$com$mysql$jdbc$RowData == null) {
                    cls10 = class$("com.mysql.jdbc.RowData");
                    class$com$mysql$jdbc$RowData = cls10;
                } else {
                    cls10 = class$com$mysql$jdbc$RowData;
                }
                clsArr3[2] = cls10;
                if (class$com$mysql$jdbc$ConnectionImpl == null) {
                    cls11 = class$("com.mysql.jdbc.ConnectionImpl");
                    class$com$mysql$jdbc$ConnectionImpl = cls11;
                } else {
                    cls11 = class$com$mysql$jdbc$ConnectionImpl;
                }
                clsArr3[3] = cls11;
                if (class$com$mysql$jdbc$StatementImpl == null) {
                    cls12 = class$("com.mysql.jdbc.StatementImpl");
                    class$com$mysql$jdbc$StatementImpl = cls12;
                } else {
                    cls12 = class$com$mysql$jdbc$StatementImpl;
                }
                clsArr3[4] = cls12;
                JDBC_4_UPD_RS_6_ARG_CTOR = cls15.getConstructor(clsArr3);
            } catch (ClassNotFoundException e) {
                throw new RuntimeException(e);
            } catch (NoSuchMethodException e2) {
                throw new RuntimeException(e2);
            } catch (SecurityException e3) {
                throw new RuntimeException(e3);
            }
        } else {
            JDBC_4_RS_4_ARG_CTOR = null;
            JDBC_4_RS_6_ARG_CTOR = null;
            JDBC_4_UPD_RS_6_ARG_CTOR = null;
        }
        MIN_DIFF_PREC = Float.parseFloat(Float.toString(Float.MIN_VALUE)) - Double.parseDouble(Float.toString(Float.MIN_VALUE));
        MAX_DIFF_PREC = Float.parseFloat(Float.toString(Float.MAX_VALUE)) - Double.parseDouble(Float.toString(Float.MAX_VALUE));
        resultCounter = 1;
        EMPTY_SPACE = new char[255];
        for (int i = 0; i < EMPTY_SPACE.length; i++) {
            EMPTY_SPACE[i] = ' ';
        }
    }

    static Class class$(String x0) {
        try {
            return Class.forName(x0);
        } catch (ClassNotFoundException x1) {
            throw new NoClassDefFoundError(x1.getMessage());
        }
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public static BigInteger convertLongToUlong(long longVal) {
        byte[] asBytes = {(byte) (longVal >>> 56), (byte) (longVal >>> 48), (byte) (longVal >>> 40), (byte) (longVal >>> 32), (byte) (longVal >>> 24), (byte) (longVal >>> 16), (byte) (longVal >>> 8), (byte) (longVal & 255)};
        return new BigInteger(1, asBytes);
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public static ResultSetImpl getInstance(long updateCount, long updateID, ConnectionImpl conn, StatementImpl creatorStmt) throws SQLException {
        return !Util.isJdbc4() ? new ResultSetImpl(updateCount, updateID, conn, creatorStmt) : (ResultSetImpl) Util.handleNewInstance(JDBC_4_RS_4_ARG_CTOR, new Object[]{Constants.longValueOf(updateCount), Constants.longValueOf(updateID), conn, creatorStmt});
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public static ResultSetImpl getInstance(String catalog, Field[] fields, RowData tuples, ConnectionImpl conn, StatementImpl creatorStmt, boolean isUpdatable) throws SQLException {
        if (Util.isJdbc4()) {
            return !isUpdatable ? (ResultSetImpl) Util.handleNewInstance(JDBC_4_RS_6_ARG_CTOR, new Object[]{catalog, fields, tuples, conn, creatorStmt}) : (ResultSetImpl) Util.handleNewInstance(JDBC_4_UPD_RS_6_ARG_CTOR, new Object[]{catalog, fields, tuples, conn, creatorStmt});
        }
        if (!isUpdatable) {
            return new ResultSetImpl(catalog, fields, tuples, conn, creatorStmt);
        }
        return new UpdatableResultSet(catalog, fields, tuples, conn, creatorStmt);
    }

    public ResultSetImpl(long updateCount, long updateID, ConnectionImpl conn, StatementImpl creatorStmt) {
        this.catalog = null;
        this.columnNameToIndex = null;
        this.columnUsed = null;
        this.connectionId = 0L;
        this.currentRow = -1;
        this.doingUpdates = false;
        this.eventSink = null;
        this.fastDateCal = null;
        this.fetchDirection = MysqlErrorNumbers.ER_HASHCHK;
        this.fetchSize = 0;
        this.fullColumnNameToIndex = null;
        this.hasBuiltIndexMapping = false;
        this.isBinaryEncoded = false;
        this.isClosed = false;
        this.nextResultSet = null;
        this.onInsertRow = false;
        this.profileSql = false;
        this.reallyResult = false;
        this.resultSetConcurrency = 0;
        this.resultSetType = 0;
        this.serverInfo = null;
        this.thisRow = null;
        this.updateId = -1L;
        this.useStrictFloatingPoint = false;
        this.useUsageAdvisor = false;
        this.warningChain = null;
        this.wasNullFlag = false;
        this.gmtCalendar = null;
        this.useFastDateParsing = false;
        this.padCharsWithSpace = false;
        this.updateCount = updateCount;
        this.updateId = updateID;
        this.reallyResult = false;
        this.fields = new Field[0];
        this.connection = conn;
        this.owningStatement = creatorStmt;
        this.retainOwningStatement = false;
        if (this.connection != null) {
            this.retainOwningStatement = this.connection.getRetainStatementAfterResultSetClose();
            this.connectionId = this.connection.getId();
        }
    }

    public ResultSetImpl(String catalog, Field[] fields, RowData tuples, ConnectionImpl conn, StatementImpl creatorStmt) throws SQLException {
        this.catalog = null;
        this.columnNameToIndex = null;
        this.columnUsed = null;
        this.connectionId = 0L;
        this.currentRow = -1;
        this.doingUpdates = false;
        this.eventSink = null;
        this.fastDateCal = null;
        this.fetchDirection = MysqlErrorNumbers.ER_HASHCHK;
        this.fetchSize = 0;
        this.fullColumnNameToIndex = null;
        this.hasBuiltIndexMapping = false;
        this.isBinaryEncoded = false;
        this.isClosed = false;
        this.nextResultSet = null;
        this.onInsertRow = false;
        this.profileSql = false;
        this.reallyResult = false;
        this.resultSetConcurrency = 0;
        this.resultSetType = 0;
        this.serverInfo = null;
        this.thisRow = null;
        this.updateId = -1L;
        this.useStrictFloatingPoint = false;
        this.useUsageAdvisor = false;
        this.warningChain = null;
        this.wasNullFlag = false;
        this.gmtCalendar = null;
        this.useFastDateParsing = false;
        this.padCharsWithSpace = false;
        this.connection = conn;
        this.retainOwningStatement = false;
        if (this.connection != null) {
            this.useStrictFloatingPoint = this.connection.getStrictFloatingPoint();
            setDefaultTimeZone(this.connection.getDefaultTimeZone());
            this.connectionId = this.connection.getId();
            this.useFastDateParsing = this.connection.getUseFastDateParsing();
            this.profileSql = this.connection.getProfileSql();
            this.retainOwningStatement = this.connection.getRetainStatementAfterResultSetClose();
        }
        this.owningStatement = creatorStmt;
        this.catalog = catalog;
        this.fields = fields;
        this.rowData = tuples;
        this.updateCount = this.rowData.size();
        this.reallyResult = true;
        if (this.rowData.size() > 0) {
            if (this.updateCount == 1 && this.thisRow == null) {
                this.rowData.close();
                this.updateCount = -1L;
            }
        } else {
            this.thisRow = null;
        }
        this.rowData.setOwner(this);
        if (this.fields != null) {
            initializeWithMetadata();
        }
    }

    @Override // com.mysql.jdbc.ResultSetInternalMethods
    public void initializeWithMetadata() throws SQLException {
        this.rowData.setMetadata(this.fields);
        if (this.profileSql || this.connection.getUseUsageAdvisor()) {
            this.columnUsed = new boolean[this.fields.length];
            this.pointOfOrigin = new Throwable();
            int i = resultCounter;
            resultCounter = i + 1;
            this.resultId = i;
            this.useUsageAdvisor = this.connection.getUseUsageAdvisor();
            this.eventSink = ProfileEventSink.getInstance(this.connection);
        }
        if (this.connection.getGatherPerformanceMetrics()) {
            this.connection.incrementNumberOfResultSetsCreated();
            Map tableNamesMap = new HashMap();
            for (int i2 = 0; i2 < this.fields.length; i2++) {
                Field f = this.fields[i2];
                String tableName = f.getOriginalTableName();
                if (tableName == null) {
                    tableName = f.getTableName();
                }
                if (tableName != null) {
                    if (this.connection.lowerCaseTableNames()) {
                        tableName = tableName.toLowerCase();
                    }
                    tableNamesMap.put(tableName, null);
                }
            }
            this.connection.reportNumberOfTablesAccessed(tableNamesMap.size());
        }
    }

    private synchronized void createCalendarIfNeeded() {
        if (this.fastDateCal == null) {
            this.fastDateCal = new GregorianCalendar(Locale.US);
            this.fastDateCal.setTimeZone(getDefaultTimeZone());
        }
    }

    @Override // java.sql.ResultSet
    public boolean absolute(int row) throws SQLException {
        boolean b;
        checkClosed();
        if (this.rowData.size() == 0) {
            b = false;
        } else {
            if (row == 0) {
                throw SQLError.createSQLException(Messages.getString("ResultSet.Cannot_absolute_position_to_row_0_110"), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
            }
            if (this.onInsertRow) {
                this.onInsertRow = false;
            }
            if (this.doingUpdates) {
                this.doingUpdates = false;
            }
            if (this.thisRow != null) {
                this.thisRow.closeOpenStreams();
            }
            if (row == 1) {
                b = first();
            } else if (row == -1) {
                b = last();
            } else if (row > this.rowData.size()) {
                afterLast();
                b = false;
            } else if (row < 0) {
                int newRowPosition = this.rowData.size() + row + 1;
                if (newRowPosition <= 0) {
                    beforeFirst();
                    b = false;
                } else {
                    b = absolute(newRowPosition);
                }
            } else {
                int row2 = row - 1;
                this.rowData.setCurrentRow(row2);
                this.thisRow = this.rowData.getAt(row2);
                b = true;
            }
        }
        return b;
    }

    @Override // java.sql.ResultSet
    public void afterLast() throws SQLException {
        checkClosed();
        if (this.onInsertRow) {
            this.onInsertRow = false;
        }
        if (this.doingUpdates) {
            this.doingUpdates = false;
        }
        if (this.thisRow != null) {
            this.thisRow.closeOpenStreams();
        }
        if (this.rowData.size() != 0) {
            this.rowData.afterLast();
            this.thisRow = null;
        }
    }

    @Override // java.sql.ResultSet
    public void beforeFirst() throws SQLException {
        checkClosed();
        if (this.onInsertRow) {
            this.onInsertRow = false;
        }
        if (this.doingUpdates) {
            this.doingUpdates = false;
        }
        if (this.rowData.size() == 0) {
            return;
        }
        if (this.thisRow != null) {
            this.thisRow.closeOpenStreams();
        }
        this.rowData.beforeFirst();
        this.thisRow = null;
    }

    @Override // com.mysql.jdbc.ResultSetInternalMethods
    public void buildIndexMapping() throws SQLException {
        int numFields = this.fields.length;
        this.columnNameToIndex = new TreeMap(String.CASE_INSENSITIVE_ORDER);
        this.fullColumnNameToIndex = new TreeMap(String.CASE_INSENSITIVE_ORDER);
        for (int i = numFields - 1; i >= 0; i--) {
            Integer index = Constants.integerValueOf(i);
            String columnName = this.fields[i].getName();
            String fullColumnName = this.fields[i].getFullName();
            if (columnName != null) {
                this.columnNameToIndex.put(columnName, index);
            }
            if (fullColumnName != null) {
                this.fullColumnNameToIndex.put(fullColumnName, index);
            }
        }
        this.hasBuiltIndexMapping = true;
    }

    @Override // java.sql.ResultSet
    public void cancelRowUpdates() throws SQLException {
        throw new NotUpdatable();
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public final void checkClosed() throws SQLException {
        if (this.isClosed) {
            throw SQLError.createSQLException(Messages.getString("ResultSet.Operation_not_allowed_after_ResultSet_closed_144"), SQLError.SQL_STATE_GENERAL_ERROR);
        }
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public final void checkColumnBounds(int columnIndex) throws SQLException {
        if (columnIndex < 1) {
            throw SQLError.createSQLException(Messages.getString("ResultSet.Column_Index_out_of_range_low", new Object[]{Constants.integerValueOf(columnIndex), Constants.integerValueOf(this.fields.length)}), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
        if (columnIndex > this.fields.length) {
            throw SQLError.createSQLException(Messages.getString("ResultSet.Column_Index_out_of_range_high", new Object[]{Constants.integerValueOf(columnIndex), Constants.integerValueOf(this.fields.length)}), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
        if (this.profileSql || this.useUsageAdvisor) {
            this.columnUsed[columnIndex - 1] = true;
        }
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public void checkRowPos() throws SQLException {
        checkClosed();
        if (!this.rowData.isDynamic() && this.rowData.size() == 0) {
            throw SQLError.createSQLException(Messages.getString("ResultSet.Illegal_operation_on_empty_result_set"), SQLError.SQL_STATE_GENERAL_ERROR);
        }
        if (this.rowData.isBeforeFirst()) {
            throw SQLError.createSQLException(Messages.getString("ResultSet.Before_start_of_result_set_146"), SQLError.SQL_STATE_GENERAL_ERROR);
        }
        if (this.rowData.isAfterLast()) {
            throw SQLError.createSQLException(Messages.getString("ResultSet.After_end_of_result_set_148"), SQLError.SQL_STATE_GENERAL_ERROR);
        }
    }

    @Override // com.mysql.jdbc.ResultSetInternalMethods
    public void clearNextResult() {
        this.nextResultSet = null;
    }

    @Override // java.sql.ResultSet
    public void clearWarnings() throws SQLException {
        this.warningChain = null;
    }

    @Override // java.sql.ResultSet, java.lang.AutoCloseable
    public void close() throws SQLException {
        realClose(true);
    }

    private int convertToZeroWithEmptyCheck() throws SQLException {
        if (this.connection.getEmptyStringsConvertToZero()) {
            return 0;
        }
        throw SQLError.createSQLException("Can't convert empty string ('') to numeric", SQLError.SQL_STATE_INVALID_CHARACTER_VALUE_FOR_CAST);
    }

    private String convertToZeroLiteralStringWithEmptyCheck() throws SQLException {
        if (this.connection.getEmptyStringsConvertToZero()) {
            return "0";
        }
        throw SQLError.createSQLException("Can't convert empty string ('') to numeric", SQLError.SQL_STATE_INVALID_CHARACTER_VALUE_FOR_CAST);
    }

    @Override // com.mysql.jdbc.ResultSetInternalMethods
    public ResultSetInternalMethods copy() throws SQLException {
        ResultSetInternalMethods rs = getInstance(this.catalog, this.fields, this.rowData, this.connection, this.owningStatement, false);
        return rs;
    }

    @Override // com.mysql.jdbc.ResultSetInternalMethods
    public void redefineFieldsForDBMD(Field[] f) {
        this.fields = f;
        for (int i = 0; i < this.fields.length; i++) {
            this.fields[i].setUseOldNameMetadata(true);
            this.fields[i].setConnection(this.connection);
        }
    }

    @Override // com.mysql.jdbc.ResultSetInternalMethods
    public void populateCachedMetaData(CachedResultSetMetaData cachedMetaData) throws SQLException {
        cachedMetaData.fields = this.fields;
        cachedMetaData.columnNameToIndex = this.columnNameToIndex;
        cachedMetaData.fullColumnNameToIndex = this.fullColumnNameToIndex;
        cachedMetaData.metadata = getMetaData();
    }

    @Override // com.mysql.jdbc.ResultSetInternalMethods
    public void initializeFromCachedMetaData(CachedResultSetMetaData cachedMetaData) {
        this.fields = cachedMetaData.fields;
        this.columnNameToIndex = cachedMetaData.columnNameToIndex;
        this.fullColumnNameToIndex = cachedMetaData.fullColumnNameToIndex;
        this.hasBuiltIndexMapping = true;
    }

    @Override // java.sql.ResultSet
    public void deleteRow() throws SQLException {
        throw new NotUpdatable();
    }

    private String extractStringFromNativeColumn(int columnIndex, int mysqlType) throws SQLException {
        int columnIndexMinusOne = columnIndex - 1;
        this.wasNullFlag = false;
        if (this.thisRow.isNull(columnIndexMinusOne)) {
            this.wasNullFlag = true;
            return null;
        }
        this.wasNullFlag = false;
        String encoding = this.fields[columnIndexMinusOne].getCharacterSet();
        return this.thisRow.getString(columnIndex - 1, encoding, this.connection);
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public synchronized Date fastDateCreate(Calendar cal, int year, int month, int day) {
        if (cal == null) {
            createCalendarIfNeeded();
            cal = this.fastDateCal;
        }
        boolean useGmtMillis = this.connection.getUseGmtMillisForDatetimes();
        return TimeUtil.fastDateCreate(useGmtMillis, useGmtMillis ? getGmtCalendar() : null, cal, year, month, day);
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public synchronized Time fastTimeCreate(Calendar cal, int hour, int minute, int second) throws SQLException {
        if (cal == null) {
            createCalendarIfNeeded();
            cal = this.fastDateCal;
        }
        return TimeUtil.fastTimeCreate(cal, hour, minute, second);
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public synchronized Timestamp fastTimestampCreate(Calendar cal, int year, int month, int day, int hour, int minute, int seconds, int secondsPart) {
        if (cal == null) {
            createCalendarIfNeeded();
            cal = this.fastDateCal;
        }
        boolean useGmtMillis = this.connection.getUseGmtMillisForDatetimes();
        return TimeUtil.fastTimestampCreate(useGmtMillis, useGmtMillis ? getGmtCalendar() : null, cal, year, month, day, hour, minute, seconds, secondsPart);
    }

    @Override // java.sql.ResultSet
    public synchronized int findColumn(String columnName) throws SQLException {
        if (!this.hasBuiltIndexMapping) {
            buildIndexMapping();
        }
        Integer index = (Integer) this.columnNameToIndex.get(columnName);
        if (index == null) {
            index = (Integer) this.fullColumnNameToIndex.get(columnName);
        }
        if (index != null) {
            return index.intValue() + 1;
        }
        for (int i = 0; i < this.fields.length; i++) {
            if (this.fields[i].getName().equalsIgnoreCase(columnName)) {
                return i + 1;
            }
            if (this.fields[i].getFullName().equalsIgnoreCase(columnName)) {
                return i + 1;
            }
        }
        throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("ResultSet.Column____112")).append(columnName).append(Messages.getString("ResultSet.___not_found._113")).toString(), SQLError.SQL_STATE_COLUMN_NOT_FOUND);
    }

    @Override // java.sql.ResultSet
    public boolean first() throws SQLException {
        checkClosed();
        if (this.rowData.isEmpty()) {
            return false;
        }
        if (this.onInsertRow) {
            this.onInsertRow = false;
        }
        if (this.doingUpdates) {
            this.doingUpdates = false;
        }
        this.rowData.beforeFirst();
        this.thisRow = this.rowData.next();
        return true;
    }

    @Override // java.sql.ResultSet
    public Array getArray(int i) throws SQLException {
        checkColumnBounds(i);
        throw new NotImplemented();
    }

    @Override // java.sql.ResultSet
    public Array getArray(String colName) throws SQLException {
        return getArray(findColumn(colName));
    }

    @Override // java.sql.ResultSet
    public InputStream getAsciiStream(int columnIndex) throws SQLException {
        checkRowPos();
        if (!this.isBinaryEncoded) {
            return getBinaryStream(columnIndex);
        }
        return getNativeBinaryStream(columnIndex);
    }

    @Override // java.sql.ResultSet
    public InputStream getAsciiStream(String columnName) throws SQLException {
        return getAsciiStream(findColumn(columnName));
    }

    @Override // java.sql.ResultSet
    public BigDecimal getBigDecimal(int columnIndex) throws SQLException {
        if (!this.isBinaryEncoded) {
            String stringVal = getString(columnIndex);
            if (stringVal != null) {
                if (stringVal.length() == 0) {
                    BigDecimal val = new BigDecimal(convertToZeroLiteralStringWithEmptyCheck());
                    return val;
                }
                try {
                    BigDecimal val2 = new BigDecimal(stringVal);
                    return val2;
                } catch (NumberFormatException e) {
                    throw SQLError.createSQLException(Messages.getString("ResultSet.Bad_format_for_BigDecimal", new Object[]{stringVal, Constants.integerValueOf(columnIndex)}), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                }
            }
            return null;
        }
        return getNativeBigDecimal(columnIndex);
    }

    @Override // java.sql.ResultSet
    public BigDecimal getBigDecimal(int columnIndex, int scale) throws SQLException {
        BigDecimal val;
        if (!this.isBinaryEncoded) {
            String stringVal = getString(columnIndex);
            if (stringVal != null) {
                if (stringVal.length() == 0) {
                    BigDecimal val2 = new BigDecimal(convertToZeroLiteralStringWithEmptyCheck());
                    try {
                        return val2.setScale(scale);
                    } catch (ArithmeticException e) {
                        try {
                            return val2.setScale(scale, 4);
                        } catch (ArithmeticException e2) {
                            throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("ResultSet.Bad_format_for_BigDecimal____124")).append(stringVal).append(Messages.getString("ResultSet.___in_column__125")).append(columnIndex).append("(").append(this.fields[columnIndex - 1]).append(").").toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                        }
                    }
                }
                try {
                    val = new BigDecimal(stringVal);
                } catch (NumberFormatException e3) {
                    if (this.fields[columnIndex - 1].getMysqlType() == 16) {
                        long valueAsLong = getNumericRepresentationOfSQLBitType(columnIndex);
                        val = new BigDecimal(valueAsLong);
                    } else {
                        throw SQLError.createSQLException(Messages.getString("ResultSet.Bad_format_for_BigDecimal", new Object[]{Constants.integerValueOf(columnIndex), stringVal}), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                    }
                }
                try {
                    return val.setScale(scale);
                } catch (ArithmeticException e4) {
                    try {
                        return val.setScale(scale, 4);
                    } catch (ArithmeticException e5) {
                        throw SQLError.createSQLException(Messages.getString("ResultSet.Bad_format_for_BigDecimal", new Object[]{Constants.integerValueOf(columnIndex), stringVal}), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                    }
                }
            }
            return null;
        }
        return getNativeBigDecimal(columnIndex, scale);
    }

    @Override // java.sql.ResultSet
    public BigDecimal getBigDecimal(String columnName) throws SQLException {
        return getBigDecimal(findColumn(columnName));
    }

    @Override // java.sql.ResultSet
    public BigDecimal getBigDecimal(String columnName, int scale) throws SQLException {
        return getBigDecimal(findColumn(columnName), scale);
    }

    private final BigDecimal getBigDecimalFromString(String stringVal, int columnIndex, int scale) throws SQLException {
        if (stringVal != null) {
            try {
                if (stringVal.length() == 0) {
                    BigDecimal bdVal = new BigDecimal(convertToZeroLiteralStringWithEmptyCheck());
                    try {
                        return bdVal.setScale(scale);
                    } catch (ArithmeticException e) {
                        try {
                            return bdVal.setScale(scale, 4);
                        } catch (ArithmeticException e2) {
                            throw new SQLException(Messages.getString("ResultSet.Bad_format_for_BigDecimal", new Object[]{stringVal, Constants.integerValueOf(columnIndex)}), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                        }
                    }
                }
                try {
                    return new BigDecimal(stringVal).setScale(scale);
                } catch (ArithmeticException e3) {
                    try {
                        return new BigDecimal(stringVal).setScale(scale, 4);
                    } catch (ArithmeticException e4) {
                        throw new SQLException(Messages.getString("ResultSet.Bad_format_for_BigDecimal", new Object[]{stringVal, Constants.integerValueOf(columnIndex)}), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                    }
                }
            } catch (NumberFormatException e5) {
                if (this.fields[columnIndex - 1].getMysqlType() == 16) {
                    long valueAsLong = getNumericRepresentationOfSQLBitType(columnIndex);
                    try {
                        return new BigDecimal(valueAsLong).setScale(scale);
                    } catch (ArithmeticException e6) {
                        try {
                            return new BigDecimal(valueAsLong).setScale(scale, 4);
                        } catch (ArithmeticException e7) {
                            throw new SQLException(Messages.getString("ResultSet.Bad_format_for_BigDecimal", new Object[]{stringVal, Constants.integerValueOf(columnIndex)}), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                        }
                    }
                }
                if (this.fields[columnIndex - 1].getMysqlType() == 1 && this.connection.getTinyInt1isBit() && this.fields[columnIndex - 1].getLength() == 1) {
                    return new BigDecimal(stringVal.equalsIgnoreCase("true") ? 1.0d : 0.0d).setScale(scale);
                }
                throw new SQLException(Messages.getString("ResultSet.Bad_format_for_BigDecimal", new Object[]{stringVal, Constants.integerValueOf(columnIndex)}), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
            }
        }
        return null;
    }

    @Override // java.sql.ResultSet
    public InputStream getBinaryStream(int columnIndex) throws SQLException {
        checkRowPos();
        if (!this.isBinaryEncoded) {
            checkColumnBounds(columnIndex);
            int columnIndexMinusOne = columnIndex - 1;
            if (this.thisRow.isNull(columnIndexMinusOne)) {
                this.wasNullFlag = true;
                return null;
            }
            this.wasNullFlag = false;
            return this.thisRow.getBinaryInputStream(columnIndexMinusOne);
        }
        return getNativeBinaryStream(columnIndex);
    }

    @Override // java.sql.ResultSet
    public InputStream getBinaryStream(String columnName) throws SQLException {
        return getBinaryStream(findColumn(columnName));
    }

    @Override // java.sql.ResultSet
    public java.sql.Blob getBlob(int columnIndex) throws SQLException {
        if (!this.isBinaryEncoded) {
            checkRowPos();
            checkColumnBounds(columnIndex);
            int columnIndexMinusOne = columnIndex - 1;
            if (this.thisRow.isNull(columnIndexMinusOne)) {
                this.wasNullFlag = true;
            } else {
                this.wasNullFlag = false;
            }
            if (this.wasNullFlag) {
                return null;
            }
            if (!this.connection.getEmulateLocators()) {
                return new Blob(this.thisRow.getColumnValue(columnIndexMinusOne));
            }
            return new BlobFromLocator(this, columnIndex);
        }
        return getNativeBlob(columnIndex);
    }

    @Override // java.sql.ResultSet
    public java.sql.Blob getBlob(String colName) throws SQLException {
        return getBlob(findColumn(colName));
    }

    @Override // java.sql.ResultSet
    public boolean getBoolean(int columnIndex) throws SQLException {
        checkColumnBounds(columnIndex);
        int columnIndexMinusOne = columnIndex - 1;
        Field field = this.fields[columnIndexMinusOne];
        if (field.getMysqlType() == 16) {
            return byteArrayToBoolean(columnIndexMinusOne);
        }
        this.wasNullFlag = false;
        int sqlType = field.getSQLType();
        switch (sqlType) {
            case -7:
            case -6:
            case -5:
            case 2:
            case 3:
            case 4:
            case 5:
            case 6:
            case 7:
            case 8:
            case 16:
                long boolVal = getLong(columnIndex, false);
                return boolVal == -1 || boolVal > 0;
            case -4:
            case -3:
            case -2:
            case -1:
            case 0:
            case 1:
            case 9:
            case 10:
            case 11:
            case 12:
            case 13:
            case 14:
            case 15:
            default:
                if (this.connection.getPedantic()) {
                    switch (sqlType) {
                        case -4:
                        case -3:
                        case -2:
                        case 70:
                        case 91:
                        case 92:
                        case 93:
                        case 2000:
                        case 2002:
                        case 2003:
                        case 2004:
                        case 2005:
                        case 2006:
                            throw SQLError.createSQLException("Required type conversion not allowed", SQLError.SQL_STATE_INVALID_CHARACTER_VALUE_FOR_CAST);
                    }
                }
                if (sqlType == -2 || sqlType == -3 || sqlType == -4 || sqlType == 2004) {
                    return byteArrayToBoolean(columnIndexMinusOne);
                }
                if (this.useUsageAdvisor) {
                    issueConversionViaParsingWarning("getBoolean()", columnIndex, this.thisRow.getColumnValue(columnIndexMinusOne), this.fields[columnIndex], new int[]{16, 5, 1, 2, 3, 8, 4});
                }
                String stringVal = getString(columnIndex);
                return getBooleanFromString(stringVal, columnIndex);
        }
    }

    private boolean byteArrayToBoolean(int columnIndexMinusOne) throws SQLException {
        Object value = this.thisRow.getColumnValue(columnIndexMinusOne);
        if (value == null) {
            this.wasNullFlag = true;
            return false;
        }
        this.wasNullFlag = false;
        if (((byte[]) value).length == 0) {
            return false;
        }
        byte boolVal = ((byte[]) value)[0];
        return boolVal == -1 || boolVal > 0;
    }

    @Override // java.sql.ResultSet
    public boolean getBoolean(String columnName) throws SQLException {
        return getBoolean(findColumn(columnName));
    }

    private final boolean getBooleanFromString(String stringVal, int columnIndex) throws SQLException {
        if (stringVal != null && stringVal.length() > 0) {
            int c = Character.toLowerCase(stringVal.charAt(0));
            return c == 116 || c == 121 || c == 49 || stringVal.equals("-1");
        }
        return false;
    }

    @Override // java.sql.ResultSet
    public byte getByte(int columnIndex) throws SQLException {
        if (!this.isBinaryEncoded) {
            String stringVal = getString(columnIndex);
            if (this.wasNullFlag || stringVal == null) {
                return (byte) 0;
            }
            return getByteFromString(stringVal, columnIndex);
        }
        return getNativeByte(columnIndex);
    }

    @Override // java.sql.ResultSet
    public byte getByte(String columnName) throws SQLException {
        return getByte(findColumn(columnName));
    }

    private final byte getByteFromString(String stringVal, int columnIndex) throws SQLException {
        if (stringVal != null && stringVal.length() == 0) {
            return (byte) convertToZeroWithEmptyCheck();
        }
        if (stringVal == null) {
            return (byte) 0;
        }
        String stringVal2 = stringVal.trim();
        try {
            int decimalIndex = stringVal2.indexOf(".");
            if (decimalIndex != -1) {
                double valueAsDouble = Double.parseDouble(stringVal2);
                if (this.connection.getJdbcCompliantTruncationForReads() && (valueAsDouble < -128.0d || valueAsDouble > 127.0d)) {
                    throwRangeException(stringVal2, columnIndex, -6);
                }
                return (byte) valueAsDouble;
            }
            long valueAsLong = Long.parseLong(stringVal2);
            if (this.connection.getJdbcCompliantTruncationForReads() && (valueAsLong < -128 || valueAsLong > 127)) {
                throwRangeException(String.valueOf(valueAsLong), columnIndex, -6);
            }
            return (byte) valueAsLong;
        } catch (NumberFormatException e) {
            throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("ResultSet.Value____173")).append(stringVal2).append(Messages.getString("ResultSet.___is_out_of_range_[-127,127]_174")).toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
    }

    @Override // java.sql.ResultSet
    public byte[] getBytes(int columnIndex) throws SQLException {
        return getBytes(columnIndex, false);
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public byte[] getBytes(int columnIndex, boolean noConversion) throws SQLException {
        if (!this.isBinaryEncoded) {
            checkRowPos();
            checkColumnBounds(columnIndex);
            int columnIndexMinusOne = columnIndex - 1;
            if (this.thisRow.isNull(columnIndexMinusOne)) {
                this.wasNullFlag = true;
            } else {
                this.wasNullFlag = false;
            }
            if (this.wasNullFlag) {
                return null;
            }
            return this.thisRow.getColumnValue(columnIndexMinusOne);
        }
        return getNativeBytes(columnIndex, noConversion);
    }

    @Override // java.sql.ResultSet
    public byte[] getBytes(String columnName) throws SQLException {
        return getBytes(findColumn(columnName));
    }

    private final byte[] getBytesFromString(String stringVal, int columnIndex) throws SQLException {
        if (stringVal != null) {
            return StringUtils.getBytes(stringVal, this.connection.getEncoding(), this.connection.getServerCharacterEncoding(), this.connection.parserKnowsUnicode(), this.connection);
        }
        return null;
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public Calendar getCalendarInstanceForSessionOrNew() {
        if (this.connection != null) {
            return this.connection.getCalendarInstanceForSessionOrNew();
        }
        return new GregorianCalendar();
    }

    @Override // java.sql.ResultSet
    public Reader getCharacterStream(int columnIndex) throws SQLException {
        if (!this.isBinaryEncoded) {
            checkColumnBounds(columnIndex);
            int columnIndexMinusOne = columnIndex - 1;
            if (this.thisRow.isNull(columnIndexMinusOne)) {
                this.wasNullFlag = true;
                return null;
            }
            this.wasNullFlag = false;
            return this.thisRow.getReader(columnIndexMinusOne);
        }
        return getNativeCharacterStream(columnIndex);
    }

    @Override // java.sql.ResultSet
    public Reader getCharacterStream(String columnName) throws SQLException {
        return getCharacterStream(findColumn(columnName));
    }

    private final Reader getCharacterStreamFromString(String stringVal, int columnIndex) throws SQLException {
        if (stringVal != null) {
            return new StringReader(stringVal);
        }
        return null;
    }

    @Override // java.sql.ResultSet
    public java.sql.Clob getClob(int i) throws SQLException {
        if (!this.isBinaryEncoded) {
            String asString = getStringForClob(i);
            if (asString == null) {
                return null;
            }
            return new Clob(asString);
        }
        return getNativeClob(i);
    }

    @Override // java.sql.ResultSet
    public java.sql.Clob getClob(String colName) throws SQLException {
        return getClob(findColumn(colName));
    }

    private final java.sql.Clob getClobFromString(String stringVal, int columnIndex) throws SQLException {
        return new Clob(stringVal);
    }

    @Override // java.sql.ResultSet
    public int getConcurrency() throws SQLException {
        return MysqlErrorNumbers.ER_DB_CREATE_EXISTS;
    }

    @Override // java.sql.ResultSet
    public String getCursorName() throws SQLException {
        throw SQLError.createSQLException(Messages.getString("ResultSet.Positioned_Update_not_supported"), SQLError.SQL_STATE_DRIVER_NOT_CAPABLE);
    }

    @Override // java.sql.ResultSet
    public Date getDate(int columnIndex) throws SQLException {
        return getDate(columnIndex, (Calendar) null);
    }

    @Override // java.sql.ResultSet
    public Date getDate(int columnIndex, Calendar cal) throws SQLException {
        if (this.isBinaryEncoded) {
            return getNativeDate(columnIndex, cal != null ? cal.getTimeZone() : getDefaultTimeZone());
        }
        if (!this.useFastDateParsing) {
            String stringVal = getStringInternal(columnIndex, false);
            if (stringVal == null) {
                return null;
            }
            return getDateFromString(stringVal, columnIndex);
        }
        checkColumnBounds(columnIndex);
        int columnIndexMinusOne = columnIndex - 1;
        if (this.thisRow.isNull(columnIndexMinusOne)) {
            this.wasNullFlag = true;
            return null;
        }
        this.wasNullFlag = false;
        return this.thisRow.getDateFast(columnIndexMinusOne, this.connection, this);
    }

    @Override // java.sql.ResultSet
    public Date getDate(String columnName) throws SQLException {
        return getDate(findColumn(columnName));
    }

    @Override // java.sql.ResultSet
    public Date getDate(String columnName, Calendar cal) throws SQLException {
        return getDate(findColumn(columnName), cal);
    }

    private final Date getDateFromString(String stringVal, int columnIndex) throws SQLException {
        int year;
        int month;
        int day;
        int year2;
        try {
            this.wasNullFlag = false;
            if (stringVal == null) {
                this.wasNullFlag = true;
                return null;
            }
            String stringVal2 = stringVal.trim();
            if (stringVal2.equals("0") || stringVal2.equals("0000-00-00") || stringVal2.equals("0000-00-00 00:00:00") || stringVal2.equals("00000000000000") || stringVal2.equals("0")) {
                if ("convertToNull".equals(this.connection.getZeroDateTimeBehavior())) {
                    this.wasNullFlag = true;
                    return null;
                }
                if ("exception".equals(this.connection.getZeroDateTimeBehavior())) {
                    throw SQLError.createSQLException(new StringBuffer().append("Value '").append(stringVal2).append("' can not be represented as java.sql.Date").toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                }
                return fastDateCreate(null, 1, 1, 1);
            }
            if (this.fields[columnIndex - 1].getMysqlType() == 7) {
                switch (stringVal2.length()) {
                    case 2:
                        int year3 = Integer.parseInt(stringVal2.substring(0, 2));
                        if (year3 <= 69) {
                            year3 += 100;
                        }
                        return fastDateCreate(null, year3 + 1900, 1, 1);
                    case 3:
                    case 5:
                    case 7:
                    case 9:
                    case 11:
                    case 13:
                    case 15:
                    case 16:
                    case 17:
                    case 18:
                    case 20:
                    default:
                        throw SQLError.createSQLException(Messages.getString("ResultSet.Bad_format_for_Date", new Object[]{stringVal2, Constants.integerValueOf(columnIndex)}), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                    case 4:
                        int year4 = Integer.parseInt(stringVal2.substring(0, 4));
                        if (year4 <= 69) {
                            year4 += 100;
                        }
                        int month2 = Integer.parseInt(stringVal2.substring(2, 4));
                        return fastDateCreate(null, year4 + 1900, month2, 1);
                    case 6:
                    case 10:
                    case 12:
                        int year5 = Integer.parseInt(stringVal2.substring(0, 2));
                        if (year5 <= 69) {
                            year5 += 100;
                        }
                        int month3 = Integer.parseInt(stringVal2.substring(2, 4));
                        int day2 = Integer.parseInt(stringVal2.substring(4, 6));
                        return fastDateCreate(null, year5 + 1900, month3, day2);
                    case 8:
                    case 14:
                        int year6 = Integer.parseInt(stringVal2.substring(0, 4));
                        int month4 = Integer.parseInt(stringVal2.substring(4, 6));
                        int day3 = Integer.parseInt(stringVal2.substring(6, 8));
                        return fastDateCreate(null, year6, month4, day3);
                    case 19:
                    case 21:
                        int year7 = Integer.parseInt(stringVal2.substring(0, 4));
                        int month5 = Integer.parseInt(stringVal2.substring(5, 7));
                        int day4 = Integer.parseInt(stringVal2.substring(8, 10));
                        return fastDateCreate(null, year7, month5, day4);
                }
            }
            if (this.fields[columnIndex - 1].getMysqlType() == 13) {
                if (stringVal2.length() == 2 || stringVal2.length() == 1) {
                    int year8 = Integer.parseInt(stringVal2);
                    if (year8 <= 69) {
                        year8 += 100;
                    }
                    year2 = year8 + 1900;
                } else {
                    year2 = Integer.parseInt(stringVal2.substring(0, 4));
                }
                return fastDateCreate(null, year2, 1, 1);
            }
            if (this.fields[columnIndex - 1].getMysqlType() == 11) {
                return fastDateCreate(null, 1970, 1, 1);
            }
            if (stringVal2.length() < 10) {
                if (stringVal2.length() == 8) {
                    return fastDateCreate(null, 1970, 1, 1);
                }
                throw SQLError.createSQLException(Messages.getString("ResultSet.Bad_format_for_Date", new Object[]{stringVal2, Constants.integerValueOf(columnIndex)}), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
            }
            if (stringVal2.length() != 18) {
                year = Integer.parseInt(stringVal2.substring(0, 4));
                month = Integer.parseInt(stringVal2.substring(5, 7));
                day = Integer.parseInt(stringVal2.substring(8, 10));
            } else {
                StringTokenizer st = new StringTokenizer(stringVal2, "- ");
                year = Integer.parseInt(st.nextToken());
                month = Integer.parseInt(st.nextToken());
                day = Integer.parseInt(st.nextToken());
            }
            return fastDateCreate(null, year, month, day);
        } catch (SQLException sqlEx) {
            throw sqlEx;
        } catch (Exception e) {
            throw SQLError.createSQLException(Messages.getString("ResultSet.Bad_format_for_Date", new Object[]{stringVal, Constants.integerValueOf(columnIndex)}), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
    }

    private TimeZone getDefaultTimeZone() {
        return this.connection.getDefaultTimeZone();
    }

    @Override // java.sql.ResultSet
    public double getDouble(int columnIndex) throws SQLException {
        if (!this.isBinaryEncoded) {
            return getDoubleInternal(columnIndex);
        }
        return getNativeDouble(columnIndex);
    }

    @Override // java.sql.ResultSet
    public double getDouble(String columnName) throws SQLException {
        return getDouble(findColumn(columnName));
    }

    private final double getDoubleFromString(String stringVal, int columnIndex) throws SQLException {
        return getDoubleInternal(stringVal, columnIndex);
    }

    protected double getDoubleInternal(int colIndex) throws SQLException {
        return getDoubleInternal(getString(colIndex), colIndex);
    }

    protected double getDoubleInternal(String stringVal, int colIndex) throws SQLException {
        if (stringVal == null) {
            return 0.0d;
        }
        try {
            if (stringVal.length() == 0) {
                return convertToZeroWithEmptyCheck();
            }
            double d = Double.parseDouble(stringVal);
            if (this.useStrictFloatingPoint) {
                if (d == 2.147483648E9d) {
                    d = 2.147483647E9d;
                } else if (d == 1.0000000036275E-15d) {
                    d = 1.0E-15d;
                } else if (d == 9.999999869911E14d) {
                    d = 9.99999999999999E14d;
                } else if (d == 1.4012984643248E-45d) {
                    d = 1.4E-45d;
                } else if (d == 1.4013E-45d) {
                    d = 1.4E-45d;
                } else if (d == 3.4028234663853E37d) {
                    d = 3.4028235E37d;
                } else if (d == -2.14748E9d) {
                    d = -2.147483648E9d;
                } else if (d == 3.40282E37d) {
                    d = 3.4028235E37d;
                }
            }
            return d;
        } catch (NumberFormatException e) {
            if (this.fields[colIndex - 1].getMysqlType() == 16) {
                long valueAsLong = getNumericRepresentationOfSQLBitType(colIndex);
                return valueAsLong;
            }
            throw SQLError.createSQLException(Messages.getString("ResultSet.Bad_format_for_number", new Object[]{stringVal, Constants.integerValueOf(colIndex)}), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
    }

    @Override // java.sql.ResultSet
    public int getFetchDirection() throws SQLException {
        return this.fetchDirection;
    }

    @Override // java.sql.ResultSet
    public int getFetchSize() throws SQLException {
        return this.fetchSize;
    }

    @Override // com.mysql.jdbc.ResultSetInternalMethods
    public char getFirstCharOfQuery() {
        return this.firstCharOfQuery;
    }

    @Override // java.sql.ResultSet
    public float getFloat(int columnIndex) throws SQLException {
        if (!this.isBinaryEncoded) {
            String val = getString(columnIndex);
            return getFloatFromString(val, columnIndex);
        }
        return getNativeFloat(columnIndex);
    }

    @Override // java.sql.ResultSet
    public float getFloat(String columnName) throws SQLException {
        return getFloat(findColumn(columnName));
    }

    private final float getFloatFromString(String val, int columnIndex) throws SQLException {
        if (val != null) {
            try {
                if (val.length() == 0) {
                    return convertToZeroWithEmptyCheck();
                }
                float f = Float.parseFloat(val);
                if (this.connection.getJdbcCompliantTruncationForReads() && (f == Float.MIN_VALUE || f == Float.MAX_VALUE)) {
                    double valAsDouble = Double.parseDouble(val);
                    if (valAsDouble < 1.401298464324817E-45d - MIN_DIFF_PREC || valAsDouble > 3.4028234663852886E38d - MAX_DIFF_PREC) {
                        throwRangeException(String.valueOf(valAsDouble), columnIndex, 6);
                    }
                }
                return f;
            } catch (NumberFormatException e) {
                try {
                    Double valueAsDouble = new Double(val);
                    float valueAsFloat = valueAsDouble.floatValue();
                    if (this.connection.getJdbcCompliantTruncationForReads() && ((this.connection.getJdbcCompliantTruncationForReads() && valueAsFloat == Float.NEGATIVE_INFINITY) || valueAsFloat == Float.POSITIVE_INFINITY)) {
                        throwRangeException(valueAsDouble.toString(), columnIndex, 6);
                    }
                    return valueAsFloat;
                } catch (NumberFormatException e2) {
                    throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("ResultSet.Invalid_value_for_getFloat()_-____200")).append(val).append(Messages.getString("ResultSet.___in_column__201")).append(columnIndex).toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                }
            }
        }
        return 0.0f;
    }

    @Override // java.sql.ResultSet
    public int getInt(int columnIndex) throws SQLException {
        checkRowPos();
        if (!this.isBinaryEncoded) {
            int columnIndexMinusOne = columnIndex - 1;
            if (this.connection.getUseFastIntParsing()) {
                checkColumnBounds(columnIndex);
                if (this.thisRow.isNull(columnIndexMinusOne)) {
                    this.wasNullFlag = true;
                } else {
                    this.wasNullFlag = false;
                }
                if (this.wasNullFlag) {
                    return 0;
                }
                if (this.thisRow.length(columnIndexMinusOne) == 0) {
                    return convertToZeroWithEmptyCheck();
                }
                boolean needsFullParse = this.thisRow.isFloatingPointNumber(columnIndexMinusOne);
                if (!needsFullParse) {
                    try {
                        return getIntWithOverflowCheck(columnIndexMinusOne);
                    } catch (NumberFormatException e) {
                        try {
                            return parseIntAsDouble(columnIndex, this.thisRow.getString(columnIndexMinusOne, this.fields[columnIndexMinusOne].getCharacterSet(), this.connection));
                        } catch (NumberFormatException e2) {
                            if (this.fields[columnIndexMinusOne].getMysqlType() == 16) {
                                long valueAsLong = getNumericRepresentationOfSQLBitType(columnIndex);
                                if (this.connection.getJdbcCompliantTruncationForReads() && (valueAsLong < -2147483648L || valueAsLong > 2147483647L)) {
                                    throwRangeException(String.valueOf(valueAsLong), columnIndex, 4);
                                }
                                return (int) valueAsLong;
                            }
                            throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("ResultSet.Invalid_value_for_getInt()_-____74")).append(this.thisRow.getString(columnIndexMinusOne, this.fields[columnIndexMinusOne].getCharacterSet(), this.connection)).append("'").toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                        }
                    }
                }
            }
            try {
                String val = getString(columnIndex);
                if (val != null) {
                    if (val.length() == 0) {
                        return convertToZeroWithEmptyCheck();
                    }
                    if (val.indexOf("e") == -1 && val.indexOf("E") == -1 && val.indexOf(".") == -1) {
                        int intVal = Integer.parseInt(val);
                        checkForIntegerTruncation(columnIndex, null, val, intVal);
                        return intVal;
                    }
                    int intVal2 = parseIntAsDouble(columnIndex, val);
                    checkForIntegerTruncation(columnIndex, null, val, intVal2);
                    return intVal2;
                }
                return 0;
            } catch (NumberFormatException e3) {
                try {
                    return parseIntAsDouble(columnIndex, null);
                } catch (NumberFormatException e4) {
                    if (this.fields[columnIndexMinusOne].getMysqlType() != 16) {
                        throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("ResultSet.Invalid_value_for_getInt()_-____74")).append((String) null).append("'").toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                    }
                    long valueAsLong2 = getNumericRepresentationOfSQLBitType(columnIndex);
                    if (this.connection.getJdbcCompliantTruncationForReads() && (valueAsLong2 < -2147483648L || valueAsLong2 > 2147483647L)) {
                        throwRangeException(String.valueOf(valueAsLong2), columnIndex, 4);
                    }
                    return (int) valueAsLong2;
                }
            }
        }
        return getNativeInt(columnIndex);
    }

    @Override // java.sql.ResultSet
    public int getInt(String columnName) throws SQLException {
        return getInt(findColumn(columnName));
    }

    private final int getIntFromString(String val, int columnIndex) throws SQLException {
        if (val != null) {
            try {
                if (val.length() == 0) {
                    return convertToZeroWithEmptyCheck();
                }
                if (val.indexOf("e") == -1 && val.indexOf("E") == -1 && val.indexOf(".") == -1) {
                    String val2 = val.trim();
                    int valueAsInt = Integer.parseInt(val2);
                    if (this.connection.getJdbcCompliantTruncationForReads() && (valueAsInt == Integer.MIN_VALUE || valueAsInt == Integer.MAX_VALUE)) {
                        long valueAsLong = Long.parseLong(val2);
                        if (valueAsLong < -2147483648L || valueAsLong > 2147483647L) {
                            throwRangeException(String.valueOf(valueAsLong), columnIndex, 4);
                        }
                    }
                    return valueAsInt;
                }
                double valueAsDouble = Double.parseDouble(val);
                if (this.connection.getJdbcCompliantTruncationForReads() && (valueAsDouble < -2.147483648E9d || valueAsDouble > 2.147483647E9d)) {
                    throwRangeException(String.valueOf(valueAsDouble), columnIndex, 4);
                }
                return (int) valueAsDouble;
            } catch (NumberFormatException e) {
                try {
                    double valueAsDouble2 = Double.parseDouble(val);
                    if (this.connection.getJdbcCompliantTruncationForReads() && (valueAsDouble2 < -2.147483648E9d || valueAsDouble2 > 2.147483647E9d)) {
                        throwRangeException(String.valueOf(valueAsDouble2), columnIndex, 4);
                    }
                    return (int) valueAsDouble2;
                } catch (NumberFormatException e2) {
                    throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("ResultSet.Invalid_value_for_getInt()_-____206")).append(val).append(Messages.getString("ResultSet.___in_column__207")).append(columnIndex).toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                }
            }
        }
        return 0;
    }

    @Override // java.sql.ResultSet
    public long getLong(int columnIndex) throws SQLException {
        return getLong(columnIndex, true);
    }

    private long getLong(int columnIndex, boolean overflowCheck) throws SQLException {
        if (!this.isBinaryEncoded) {
            checkRowPos();
            int columnIndexMinusOne = columnIndex - 1;
            if (this.connection.getUseFastIntParsing()) {
                checkColumnBounds(columnIndex);
                if (this.thisRow.isNull(columnIndexMinusOne)) {
                    this.wasNullFlag = true;
                } else {
                    this.wasNullFlag = false;
                }
                if (this.wasNullFlag) {
                    return 0L;
                }
                if (this.thisRow.length(columnIndexMinusOne) == 0) {
                    return convertToZeroWithEmptyCheck();
                }
                boolean needsFullParse = this.thisRow.isFloatingPointNumber(columnIndexMinusOne);
                if (!needsFullParse) {
                    try {
                        return getLongWithOverflowCheck(columnIndexMinusOne, overflowCheck);
                    } catch (NumberFormatException e) {
                        try {
                            return parseLongAsDouble(columnIndex, this.thisRow.getString(columnIndexMinusOne, this.fields[columnIndexMinusOne].getCharacterSet(), this.connection));
                        } catch (NumberFormatException e2) {
                            if (this.fields[columnIndexMinusOne].getMysqlType() == 16) {
                                return getNumericRepresentationOfSQLBitType(columnIndex);
                            }
                            throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("ResultSet.Invalid_value_for_getLong()_-____79")).append(this.thisRow.getString(columnIndexMinusOne, this.fields[columnIndexMinusOne].getCharacterSet(), this.connection)).append("'").toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                        }
                    }
                }
            }
            try {
                String val = getString(columnIndex);
                if (val != null) {
                    if (val.length() == 0) {
                        return convertToZeroWithEmptyCheck();
                    }
                    if (val.indexOf("e") == -1 && val.indexOf("E") == -1) {
                        return parseLongWithOverflowCheck(columnIndex, null, val, overflowCheck);
                    }
                    return parseLongAsDouble(columnIndex, val);
                }
                return 0L;
            } catch (NumberFormatException e3) {
                try {
                    return parseLongAsDouble(columnIndex, null);
                } catch (NumberFormatException e4) {
                    throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("ResultSet.Invalid_value_for_getLong()_-____79")).append((String) null).append("'").toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                }
            }
        }
        return getNativeLong(columnIndex, overflowCheck, true);
    }

    @Override // java.sql.ResultSet
    public long getLong(String columnName) throws SQLException {
        return getLong(findColumn(columnName));
    }

    private final long getLongFromString(String val, int columnIndex) throws SQLException {
        if (val != null) {
            try {
                if (val.length() == 0) {
                    return convertToZeroWithEmptyCheck();
                }
                if (val.indexOf("e") == -1 && val.indexOf("E") == -1) {
                    return parseLongWithOverflowCheck(columnIndex, null, val, true);
                }
                return parseLongAsDouble(columnIndex, val);
            } catch (NumberFormatException e) {
                try {
                    return parseLongAsDouble(columnIndex, val);
                } catch (NumberFormatException e2) {
                    throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("ResultSet.Invalid_value_for_getLong()_-____211")).append(val).append(Messages.getString("ResultSet.___in_column__212")).append(columnIndex).toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                }
            }
        }
        return 0L;
    }

    @Override // java.sql.ResultSet
    public java.sql.ResultSetMetaData getMetaData() throws SQLException {
        checkClosed();
        return new ResultSetMetaData(this.fields, this.connection.getUseOldAliasMetadataBehavior());
    }

    protected Array getNativeArray(int i) throws SQLException {
        throw new NotImplemented();
    }

    protected InputStream getNativeAsciiStream(int columnIndex) throws SQLException {
        checkRowPos();
        return getNativeBinaryStream(columnIndex);
    }

    protected BigDecimal getNativeBigDecimal(int columnIndex) throws SQLException {
        checkColumnBounds(columnIndex);
        int scale = this.fields[columnIndex - 1].getDecimals();
        return getNativeBigDecimal(columnIndex, scale);
    }

    protected BigDecimal getNativeBigDecimal(int columnIndex, int scale) throws SQLException {
        String stringVal;
        checkColumnBounds(columnIndex);
        Field f = this.fields[columnIndex - 1];
        Object value = this.thisRow.getColumnValue(columnIndex - 1);
        if (value == null) {
            this.wasNullFlag = true;
            return null;
        }
        this.wasNullFlag = false;
        switch (f.getSQLType()) {
            case 2:
            case 3:
                stringVal = StringUtils.toAsciiString((byte[]) value);
                break;
            default:
                stringVal = getNativeString(columnIndex);
                break;
        }
        return getBigDecimalFromString(stringVal, columnIndex, scale);
    }

    protected InputStream getNativeBinaryStream(int columnIndex) throws SQLException {
        checkRowPos();
        int columnIndexMinusOne = columnIndex - 1;
        if (this.thisRow.isNull(columnIndexMinusOne)) {
            this.wasNullFlag = true;
            return null;
        }
        this.wasNullFlag = false;
        switch (this.fields[columnIndexMinusOne].getSQLType()) {
            case -7:
            case -4:
            case -3:
            case -2:
            case 2004:
                return this.thisRow.getBinaryInputStream(columnIndexMinusOne);
            default:
                byte[] b = getNativeBytes(columnIndex, false);
                if (b != null) {
                    return new ByteArrayInputStream(b);
                }
                return null;
        }
    }

    protected java.sql.Blob getNativeBlob(int columnIndex) throws SQLException {
        byte[] dataAsBytes;
        checkRowPos();
        checkColumnBounds(columnIndex);
        Object value = this.thisRow.getColumnValue(columnIndex - 1);
        if (value == null) {
            this.wasNullFlag = true;
        } else {
            this.wasNullFlag = false;
        }
        if (this.wasNullFlag) {
            return null;
        }
        int mysqlType = this.fields[columnIndex - 1].getMysqlType();
        switch (mysqlType) {
            case 249:
            case 250:
            case 251:
            case MysqlDefs.FIELD_TYPE_BLOB /* 252 */:
                dataAsBytes = (byte[]) value;
                break;
            default:
                dataAsBytes = getNativeBytes(columnIndex, false);
                break;
        }
        if (!this.connection.getEmulateLocators()) {
            return new Blob(dataAsBytes);
        }
        return new BlobFromLocator(this, columnIndex);
    }

    public static boolean arraysEqual(byte[] left, byte[] right) {
        if (left == null) {
            return right == null;
        }
        if (right == null || left.length != right.length) {
            return false;
        }
        for (int i = 0; i < left.length; i++) {
            if (left[i] != right[i]) {
                return false;
            }
        }
        return true;
    }

    protected byte getNativeByte(int columnIndex) throws SQLException {
        return getNativeByte(columnIndex, true);
    }

    protected byte getNativeByte(int columnIndex, boolean overflowCheck) throws SQLException {
        checkRowPos();
        checkColumnBounds(columnIndex);
        Object value = this.thisRow.getColumnValue(columnIndex - 1);
        if (value == null) {
            this.wasNullFlag = true;
            return (byte) 0;
        }
        if (value == null) {
            this.wasNullFlag = true;
        } else {
            this.wasNullFlag = false;
        }
        if (this.wasNullFlag) {
            return (byte) 0;
        }
        int columnIndex2 = columnIndex - 1;
        Field field = this.fields[columnIndex2];
        switch (field.getMysqlType()) {
            case 1:
                byte valueAsByte = ((byte[]) value)[0];
                if (!field.isUnsigned()) {
                    return valueAsByte;
                }
                short valueAsShort = valueAsByte >= 0 ? valueAsByte : (short) (valueAsByte + 256);
                if (overflowCheck && this.connection.getJdbcCompliantTruncationForReads() && valueAsShort > 127) {
                    throwRangeException(String.valueOf((int) valueAsShort), columnIndex2 + 1, -6);
                }
                return (byte) valueAsShort;
            case 2:
            case 13:
                short valueAsShort2 = getNativeShort(columnIndex2 + 1);
                if (overflowCheck && this.connection.getJdbcCompliantTruncationForReads() && (valueAsShort2 < -128 || valueAsShort2 > 127)) {
                    throwRangeException(String.valueOf((int) valueAsShort2), columnIndex2 + 1, -6);
                }
                return (byte) valueAsShort2;
            case 3:
            case 9:
                int valueAsInt = getNativeInt(columnIndex2 + 1, false);
                if (overflowCheck && this.connection.getJdbcCompliantTruncationForReads() && (valueAsInt < -128 || valueAsInt > 127)) {
                    throwRangeException(String.valueOf(valueAsInt), columnIndex2 + 1, -6);
                }
                return (byte) valueAsInt;
            case 4:
                float valueAsFloat = getNativeFloat(columnIndex2 + 1);
                if (overflowCheck && this.connection.getJdbcCompliantTruncationForReads() && (valueAsFloat < -128.0f || valueAsFloat > 127.0f)) {
                    throwRangeException(String.valueOf(valueAsFloat), columnIndex2 + 1, -6);
                }
                return (byte) valueAsFloat;
            case 5:
                double valueAsDouble = getNativeDouble(columnIndex2 + 1);
                if (overflowCheck && this.connection.getJdbcCompliantTruncationForReads() && (valueAsDouble < -128.0d || valueAsDouble > 127.0d)) {
                    throwRangeException(String.valueOf(valueAsDouble), columnIndex2 + 1, -6);
                }
                return (byte) valueAsDouble;
            case 6:
            case 7:
            case 10:
            case 11:
            case 12:
            case 14:
            case 15:
            default:
                if (this.useUsageAdvisor) {
                    issueConversionViaParsingWarning("getByte()", columnIndex2, this.thisRow.getColumnValue(columnIndex2 - 1), this.fields[columnIndex2], new int[]{5, 1, 2, 3, 8, 4});
                }
                return getByteFromString(getNativeString(columnIndex2 + 1), columnIndex2 + 1);
            case 8:
                long valueAsLong = getNativeLong(columnIndex2 + 1, false, true);
                if (overflowCheck && this.connection.getJdbcCompliantTruncationForReads() && (valueAsLong < -128 || valueAsLong > 127)) {
                    throwRangeException(String.valueOf(valueAsLong), columnIndex2 + 1, -6);
                }
                return (byte) valueAsLong;
            case 16:
                long valueAsLong2 = getNumericRepresentationOfSQLBitType(columnIndex2 + 1);
                if (overflowCheck && this.connection.getJdbcCompliantTruncationForReads() && (valueAsLong2 < -128 || valueAsLong2 > 127)) {
                    throwRangeException(String.valueOf(valueAsLong2), columnIndex2 + 1, -6);
                }
                return (byte) valueAsLong2;
        }
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public byte[] getNativeBytes(int columnIndex, boolean noConversion) throws SQLException {
        checkRowPos();
        checkColumnBounds(columnIndex);
        Object value = this.thisRow.getColumnValue(columnIndex - 1);
        if (value == null) {
            this.wasNullFlag = true;
        } else {
            this.wasNullFlag = false;
        }
        if (this.wasNullFlag) {
            return null;
        }
        Field field = this.fields[columnIndex - 1];
        int mysqlType = field.getMysqlType();
        if (noConversion) {
            mysqlType = 252;
        }
        switch (mysqlType) {
            case 16:
            case 249:
            case 250:
            case 251:
            case MysqlDefs.FIELD_TYPE_BLOB /* 252 */:
                return (byte[]) value;
            default:
                int sqlType = field.getSQLType();
                if (sqlType == -3 || sqlType == -2) {
                    return (byte[]) value;
                }
                return getBytesFromString(getNativeString(columnIndex), columnIndex);
        }
    }

    protected Reader getNativeCharacterStream(int columnIndex) throws SQLException {
        int columnIndexMinusOne = columnIndex - 1;
        switch (this.fields[columnIndexMinusOne].getSQLType()) {
            case -1:
            case 1:
            case 12:
            case 2005:
                if (this.thisRow.isNull(columnIndexMinusOne)) {
                    this.wasNullFlag = true;
                    return null;
                }
                this.wasNullFlag = false;
                return this.thisRow.getReader(columnIndexMinusOne);
            default:
                String asString = getStringForClob(columnIndex);
                if (asString == null) {
                    return null;
                }
                return getCharacterStreamFromString(asString, columnIndex);
        }
    }

    protected java.sql.Clob getNativeClob(int columnIndex) throws SQLException {
        String stringVal = getStringForClob(columnIndex);
        if (stringVal == null) {
            return null;
        }
        return getClobFromString(stringVal, columnIndex);
    }

    private String getNativeConvertToString(int columnIndex, Field field) throws SQLException {
        int sqlType = field.getSQLType();
        int mysqlType = field.getMysqlType();
        switch (sqlType) {
            case -7:
                return String.valueOf(getNumericRepresentationOfSQLBitType(columnIndex));
            case -6:
                byte tinyintVal = getNativeByte(columnIndex, false);
                if (this.wasNullFlag) {
                    return null;
                }
                if (!field.isUnsigned() || tinyintVal >= 0) {
                    return String.valueOf((int) tinyintVal);
                }
                short unsignedTinyVal = (short) (tinyintVal & 255);
                return String.valueOf((int) unsignedTinyVal);
            case -5:
                if (!field.isUnsigned()) {
                    long longVal = getNativeLong(columnIndex, false, true);
                    if (this.wasNullFlag) {
                        return null;
                    }
                    return String.valueOf(longVal);
                }
                long longVal2 = getNativeLong(columnIndex, false, false);
                if (this.wasNullFlag) {
                    return null;
                }
                return String.valueOf(convertLongToUlong(longVal2));
            case -4:
            case -3:
            case -2:
                if (!field.isBlob()) {
                    return extractStringFromNativeColumn(columnIndex, mysqlType);
                }
                if (!field.isBinary()) {
                    return extractStringFromNativeColumn(columnIndex, mysqlType);
                }
                byte[] data = getBytes(columnIndex);
                Object obj = data;
                if (data != null && data.length >= 2) {
                    if (data[0] == -84 && data[1] == -19) {
                        try {
                            ByteArrayInputStream bytesIn = new ByteArrayInputStream(data);
                            ObjectInputStream objIn = new ObjectInputStream(bytesIn);
                            obj = objIn.readObject();
                            objIn.close();
                            bytesIn.close();
                        } catch (IOException e) {
                            obj = data;
                        } catch (ClassNotFoundException cnfe) {
                            throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("ResultSet.Class_not_found___91")).append(cnfe.toString()).append(Messages.getString("ResultSet._while_reading_serialized_object_92")).toString());
                        }
                    }
                    return obj.toString();
                }
                return extractStringFromNativeColumn(columnIndex, mysqlType);
            case -1:
            case 1:
            case 12:
                return extractStringFromNativeColumn(columnIndex, mysqlType);
            case 2:
            case 3:
                String stringVal = StringUtils.toAsciiString(this.thisRow.getColumnValue(columnIndex - 1));
                if (stringVal != null) {
                    this.wasNullFlag = false;
                    if (stringVal.length() == 0) {
                        BigDecimal val = new BigDecimal(0.0d);
                        return val.toString();
                    }
                    try {
                        BigDecimal val2 = new BigDecimal(stringVal);
                        return val2.toString();
                    } catch (NumberFormatException e2) {
                        throw SQLError.createSQLException(Messages.getString("ResultSet.Bad_format_for_BigDecimal", new Object[]{stringVal, Constants.integerValueOf(columnIndex)}), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                    }
                }
                this.wasNullFlag = true;
                return null;
            case 4:
                int intVal = getNativeInt(columnIndex, false);
                if (this.wasNullFlag) {
                    return null;
                }
                if (!field.isUnsigned() || intVal >= 0 || field.getMysqlType() == 9) {
                    return String.valueOf(intVal);
                }
                long longVal3 = intVal & 4294967295L;
                return String.valueOf(longVal3);
            case 5:
                int intVal2 = getNativeInt(columnIndex, false);
                if (this.wasNullFlag) {
                    return null;
                }
                if (!field.isUnsigned() || intVal2 >= 0) {
                    return String.valueOf(intVal2);
                }
                return String.valueOf(intVal2 & 65535);
            case 6:
            case 8:
                double doubleVal = getNativeDouble(columnIndex);
                if (this.wasNullFlag) {
                    return null;
                }
                return String.valueOf(doubleVal);
            case 7:
                float floatVal = getNativeFloat(columnIndex);
                if (this.wasNullFlag) {
                    return null;
                }
                return String.valueOf(floatVal);
            case 16:
                boolean booleanVal = getBoolean(columnIndex);
                if (this.wasNullFlag) {
                    return null;
                }
                return String.valueOf(booleanVal);
            case 91:
                if (mysqlType == 13) {
                    short shortVal = getNativeShort(columnIndex);
                    if (!this.connection.getYearIsDateType()) {
                        if (this.wasNullFlag) {
                            return null;
                        }
                        return String.valueOf((int) shortVal);
                    }
                    if (field.getLength() == 2) {
                        if (shortVal <= 69) {
                            shortVal = (short) (shortVal + 100);
                        }
                        shortVal = (short) (shortVal + 1900);
                    }
                    return fastDateCreate(null, shortVal, 1, 1).toString();
                }
                Date dt = getNativeDate(columnIndex);
                if (dt == null) {
                    return null;
                }
                return String.valueOf(dt);
            case 92:
                Time tm = getNativeTime(columnIndex, null, this.defaultTimeZone, false);
                if (tm == null) {
                    return null;
                }
                return String.valueOf(tm);
            case 93:
                Timestamp tstamp = getNativeTimestamp(columnIndex, null, this.defaultTimeZone, false);
                if (tstamp == null) {
                    return null;
                }
                String result = String.valueOf(tstamp);
                if (!this.connection.getNoDatetimeStringSync()) {
                    return result;
                }
                if (result.endsWith(".0")) {
                    return result.substring(0, result.length() - 2);
                }
                break;
        }
        return extractStringFromNativeColumn(columnIndex, mysqlType);
    }

    protected Date getNativeDate(int columnIndex) throws SQLException {
        return getNativeDate(columnIndex, null);
    }

    protected Date getNativeDate(int columnIndex, TimeZone tz) throws SQLException {
        Date dateToReturn;
        checkRowPos();
        checkColumnBounds(columnIndex);
        int columnIndexMinusOne = columnIndex - 1;
        int mysqlType = this.fields[columnIndexMinusOne].getMysqlType();
        if (mysqlType == 10) {
            dateToReturn = this.thisRow.getNativeDate(columnIndexMinusOne, this.connection, this);
        } else {
            boolean rollForward = (tz == null || tz.equals(getDefaultTimeZone())) ? false : true;
            dateToReturn = (Date) this.thisRow.getNativeDateTimeValue(columnIndexMinusOne, null, 91, mysqlType, tz, rollForward, this.connection, this);
        }
        if (dateToReturn == null) {
            this.wasNullFlag = true;
            return null;
        }
        this.wasNullFlag = false;
        return dateToReturn;
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    public Date getNativeDateViaParseConversion(int columnIndex) throws SQLException {
        if (this.useUsageAdvisor) {
            issueConversionViaParsingWarning("getDate()", columnIndex, this.thisRow.getColumnValue(columnIndex - 1), this.fields[columnIndex - 1], new int[]{10});
        }
        String stringVal = getNativeString(columnIndex);
        return getDateFromString(stringVal, columnIndex);
    }

    protected double getNativeDouble(int columnIndex) throws SQLException {
        checkRowPos();
        checkColumnBounds(columnIndex);
        int columnIndex2 = columnIndex - 1;
        if (this.thisRow.isNull(columnIndex2)) {
            this.wasNullFlag = true;
            return 0.0d;
        }
        this.wasNullFlag = false;
        Field f = this.fields[columnIndex2];
        switch (f.getMysqlType()) {
            case 1:
                if (!f.isUnsigned()) {
                    return getNativeByte(columnIndex2 + 1);
                }
                return getNativeShort(columnIndex2 + 1);
            case 2:
            case 13:
                if (!f.isUnsigned()) {
                    return getNativeShort(columnIndex2 + 1);
                }
                return getNativeInt(columnIndex2 + 1);
            case 3:
            case 9:
                if (!f.isUnsigned()) {
                    return getNativeInt(columnIndex2 + 1);
                }
                return getNativeLong(columnIndex2 + 1);
            case 4:
                return getNativeFloat(columnIndex2 + 1);
            case 5:
                return this.thisRow.getNativeDouble(columnIndex2);
            case 6:
            case 7:
            case 10:
            case 11:
            case 12:
            case 14:
            case 15:
            default:
                String stringVal = getNativeString(columnIndex2 + 1);
                if (this.useUsageAdvisor) {
                    issueConversionViaParsingWarning("getDouble()", columnIndex2, stringVal, this.fields[columnIndex2], new int[]{5, 1, 2, 3, 8, 4});
                }
                return getDoubleFromString(stringVal, columnIndex2 + 1);
            case 8:
                long valueAsLong = getNativeLong(columnIndex2 + 1);
                if (!f.isUnsigned()) {
                    return valueAsLong;
                }
                BigInteger asBigInt = convertLongToUlong(valueAsLong);
                return asBigInt.doubleValue();
            case 16:
                return getNumericRepresentationOfSQLBitType(columnIndex2 + 1);
        }
    }

    protected float getNativeFloat(int columnIndex) throws SQLException {
        checkRowPos();
        checkColumnBounds(columnIndex);
        int columnIndex2 = columnIndex - 1;
        if (this.thisRow.isNull(columnIndex2)) {
            this.wasNullFlag = true;
            return 0.0f;
        }
        this.wasNullFlag = false;
        Field f = this.fields[columnIndex2];
        switch (f.getMysqlType()) {
            case 1:
                if (!f.isUnsigned()) {
                    return getNativeByte(columnIndex2 + 1);
                }
                return getNativeShort(columnIndex2 + 1);
            case 2:
            case 13:
                if (!f.isUnsigned()) {
                    return getNativeShort(columnIndex2 + 1);
                }
                return getNativeInt(columnIndex2 + 1);
            case 3:
            case 9:
                if (!f.isUnsigned()) {
                    return getNativeInt(columnIndex2 + 1);
                }
                return (float) getNativeLong(columnIndex2 + 1);
            case 4:
                return this.thisRow.getNativeFloat(columnIndex2);
            case 5:
                Double valueAsDouble = new Double(getNativeDouble(columnIndex2 + 1));
                float valueAsFloat = valueAsDouble.floatValue();
                if ((this.connection.getJdbcCompliantTruncationForReads() && valueAsFloat == Float.NEGATIVE_INFINITY) || valueAsFloat == Float.POSITIVE_INFINITY) {
                    throwRangeException(valueAsDouble.toString(), columnIndex2 + 1, 6);
                }
                return (float) getNativeDouble(columnIndex2 + 1);
            case 6:
            case 7:
            case 10:
            case 11:
            case 12:
            case 14:
            case 15:
            default:
                String stringVal = getNativeString(columnIndex2 + 1);
                if (this.useUsageAdvisor) {
                    issueConversionViaParsingWarning("getFloat()", columnIndex2, stringVal, this.fields[columnIndex2], new int[]{5, 1, 2, 3, 8, 4});
                }
                return getFloatFromString(stringVal, columnIndex2 + 1);
            case 8:
                long valueAsLong = getNativeLong(columnIndex2 + 1);
                if (!f.isUnsigned()) {
                    return (float) valueAsLong;
                }
                BigInteger asBigInt = convertLongToUlong(valueAsLong);
                return asBigInt.floatValue();
            case 16:
                return (float) getNumericRepresentationOfSQLBitType(columnIndex2 + 1);
        }
    }

    protected int getNativeInt(int columnIndex) throws SQLException {
        return getNativeInt(columnIndex, true);
    }

    protected int getNativeInt(int columnIndex, boolean overflowCheck) throws SQLException {
        checkRowPos();
        checkColumnBounds(columnIndex);
        int columnIndex2 = columnIndex - 1;
        if (this.thisRow.isNull(columnIndex2)) {
            this.wasNullFlag = true;
            return 0;
        }
        this.wasNullFlag = false;
        Field f = this.fields[columnIndex2];
        switch (f.getMysqlType()) {
            case 1:
                byte tinyintVal = getNativeByte(columnIndex2 + 1, false);
                if (!f.isUnsigned() || tinyintVal >= 0) {
                    return tinyintVal;
                }
                return tinyintVal + 256;
            case 2:
            case 13:
                short asShort = getNativeShort(columnIndex2 + 1, false);
                if (!f.isUnsigned() || asShort >= 0) {
                    return asShort;
                }
                return asShort + 65536;
            case 3:
            case 9:
                int valueAsInt = this.thisRow.getNativeInt(columnIndex2);
                if (!f.isUnsigned()) {
                    return valueAsInt;
                }
                long valueAsLong = valueAsInt >= 0 ? valueAsInt : valueAsInt + 4294967296L;
                if (overflowCheck && this.connection.getJdbcCompliantTruncationForReads() && valueAsLong > 2147483647L) {
                    throwRangeException(String.valueOf(valueAsLong), columnIndex2 + 1, 4);
                }
                return (int) valueAsLong;
            case 4:
                double valueAsDouble = getNativeFloat(columnIndex2 + 1);
                if (overflowCheck && this.connection.getJdbcCompliantTruncationForReads() && (valueAsDouble < -2.147483648E9d || valueAsDouble > 2.147483647E9d)) {
                    throwRangeException(String.valueOf(valueAsDouble), columnIndex2 + 1, 4);
                }
                return (int) valueAsDouble;
            case 5:
                double valueAsDouble2 = getNativeDouble(columnIndex2 + 1);
                if (overflowCheck && this.connection.getJdbcCompliantTruncationForReads() && (valueAsDouble2 < -2.147483648E9d || valueAsDouble2 > 2.147483647E9d)) {
                    throwRangeException(String.valueOf(valueAsDouble2), columnIndex2 + 1, 4);
                }
                return (int) valueAsDouble2;
            case 6:
            case 7:
            case 10:
            case 11:
            case 12:
            case 14:
            case 15:
            default:
                String stringVal = getNativeString(columnIndex2 + 1);
                if (this.useUsageAdvisor) {
                    issueConversionViaParsingWarning("getInt()", columnIndex2, stringVal, this.fields[columnIndex2], new int[]{5, 1, 2, 3, 8, 4});
                }
                return getIntFromString(stringVal, columnIndex2 + 1);
            case 8:
                long valueAsLong2 = getNativeLong(columnIndex2 + 1, false, true);
                if (overflowCheck && this.connection.getJdbcCompliantTruncationForReads() && (valueAsLong2 < -2147483648L || valueAsLong2 > 2147483647L)) {
                    throwRangeException(String.valueOf(valueAsLong2), columnIndex2 + 1, 4);
                }
                return (int) valueAsLong2;
            case 16:
                long valueAsLong3 = getNumericRepresentationOfSQLBitType(columnIndex2 + 1);
                if (overflowCheck && this.connection.getJdbcCompliantTruncationForReads() && (valueAsLong3 < -2147483648L || valueAsLong3 > 2147483647L)) {
                    throwRangeException(String.valueOf(valueAsLong3), columnIndex2 + 1, 4);
                }
                return (short) valueAsLong3;
        }
    }

    protected long getNativeLong(int columnIndex) throws SQLException {
        return getNativeLong(columnIndex, true, true);
    }

    protected long getNativeLong(int columnIndex, boolean overflowCheck, boolean expandUnsignedLong) throws SQLException {
        checkRowPos();
        checkColumnBounds(columnIndex);
        int columnIndex2 = columnIndex - 1;
        if (this.thisRow.isNull(columnIndex2)) {
            this.wasNullFlag = true;
            return 0L;
        }
        this.wasNullFlag = false;
        Field f = this.fields[columnIndex2];
        switch (f.getMysqlType()) {
            case 1:
                if (!f.isUnsigned()) {
                    return getNativeByte(columnIndex2 + 1);
                }
                return getNativeInt(columnIndex2 + 1);
            case 2:
                if (!f.isUnsigned()) {
                    return getNativeShort(columnIndex2 + 1);
                }
                return getNativeInt(columnIndex2 + 1, false);
            case 3:
            case 9:
                int asInt = getNativeInt(columnIndex2 + 1, false);
                if (!f.isUnsigned() || asInt >= 0) {
                    return asInt;
                }
                return asInt + 4294967296L;
            case 4:
                double valueAsDouble = getNativeFloat(columnIndex2 + 1);
                if (overflowCheck && this.connection.getJdbcCompliantTruncationForReads() && (valueAsDouble < -9.223372036854776E18d || valueAsDouble > 9.223372036854776E18d)) {
                    throwRangeException(String.valueOf(valueAsDouble), columnIndex2 + 1, -5);
                }
                return (long) valueAsDouble;
            case 5:
                double valueAsDouble2 = getNativeDouble(columnIndex2 + 1);
                if (overflowCheck && this.connection.getJdbcCompliantTruncationForReads() && (valueAsDouble2 < -9.223372036854776E18d || valueAsDouble2 > 9.223372036854776E18d)) {
                    throwRangeException(String.valueOf(valueAsDouble2), columnIndex2 + 1, -5);
                }
                return (long) valueAsDouble2;
            case 6:
            case 7:
            case 10:
            case 11:
            case 12:
            case 14:
            case 15:
            default:
                String stringVal = getNativeString(columnIndex2 + 1);
                if (this.useUsageAdvisor) {
                    issueConversionViaParsingWarning("getLong()", columnIndex2, stringVal, this.fields[columnIndex2], new int[]{5, 1, 2, 3, 8, 4});
                }
                return getLongFromString(stringVal, columnIndex2 + 1);
            case 8:
                long valueAsLong = this.thisRow.getNativeLong(columnIndex2);
                if (!f.isUnsigned() || !expandUnsignedLong) {
                    return valueAsLong;
                }
                BigInteger asBigInt = convertLongToUlong(valueAsLong);
                if (overflowCheck && this.connection.getJdbcCompliantTruncationForReads() && (asBigInt.compareTo(new BigInteger(String.valueOf(Long.MAX_VALUE))) > 0 || asBigInt.compareTo(new BigInteger(String.valueOf(Long.MIN_VALUE))) < 0)) {
                    throwRangeException(asBigInt.toString(), columnIndex2 + 1, -5);
                }
                return getLongFromString(asBigInt.toString(), columnIndex2 + 1);
            case 13:
                return getNativeShort(columnIndex2 + 1);
            case 16:
                return getNumericRepresentationOfSQLBitType(columnIndex2 + 1);
        }
    }

    protected Ref getNativeRef(int i) throws SQLException {
        throw new NotImplemented();
    }

    protected short getNativeShort(int columnIndex) throws SQLException {
        return getNativeShort(columnIndex, true);
    }

    protected short getNativeShort(int columnIndex, boolean overflowCheck) throws SQLException {
        checkRowPos();
        checkColumnBounds(columnIndex);
        int columnIndex2 = columnIndex - 1;
        if (this.thisRow.isNull(columnIndex2)) {
            this.wasNullFlag = true;
            return (short) 0;
        }
        this.wasNullFlag = false;
        Field f = this.fields[columnIndex2];
        switch (f.getMysqlType()) {
            case 1:
                byte tinyintVal = getNativeByte(columnIndex2 + 1, false);
                if (!f.isUnsigned() || tinyintVal >= 0) {
                    return tinyintVal;
                }
                return (short) (tinyintVal + 256);
            case 2:
            case 13:
                short asShort = this.thisRow.getNativeShort(columnIndex2);
                if (!f.isUnsigned()) {
                    return asShort;
                }
                int valueAsInt = asShort & 65535;
                if (overflowCheck && this.connection.getJdbcCompliantTruncationForReads() && valueAsInt > 32767) {
                    throwRangeException(String.valueOf(valueAsInt), columnIndex2 + 1, 5);
                }
                return (short) valueAsInt;
            case 3:
            case 9:
                if (!f.isUnsigned()) {
                    int valueAsInt2 = getNativeInt(columnIndex2 + 1, false);
                    if ((overflowCheck && this.connection.getJdbcCompliantTruncationForReads() && valueAsInt2 > 32767) || valueAsInt2 < -32768) {
                        throwRangeException(String.valueOf(valueAsInt2), columnIndex2 + 1, 5);
                    }
                    return (short) valueAsInt2;
                }
                long valueAsLong = getNativeLong(columnIndex2 + 1, false, true);
                if (overflowCheck && this.connection.getJdbcCompliantTruncationForReads() && valueAsLong > 32767) {
                    throwRangeException(String.valueOf(valueAsLong), columnIndex2 + 1, 5);
                }
                return (short) valueAsLong;
            case 4:
                float valueAsFloat = getNativeFloat(columnIndex2 + 1);
                if (overflowCheck && this.connection.getJdbcCompliantTruncationForReads() && (valueAsFloat < -32768.0f || valueAsFloat > 32767.0f)) {
                    throwRangeException(String.valueOf(valueAsFloat), columnIndex2 + 1, 5);
                }
                return (short) valueAsFloat;
            case 5:
                double valueAsDouble = getNativeDouble(columnIndex2 + 1);
                if (overflowCheck && this.connection.getJdbcCompliantTruncationForReads() && (valueAsDouble < -32768.0d || valueAsDouble > 32767.0d)) {
                    throwRangeException(String.valueOf(valueAsDouble), columnIndex2 + 1, 5);
                }
                return (short) valueAsDouble;
            case 6:
            case 7:
            case 10:
            case 11:
            case 12:
            default:
                String stringVal = getNativeString(columnIndex2 + 1);
                if (this.useUsageAdvisor) {
                    issueConversionViaParsingWarning("getShort()", columnIndex2, stringVal, this.fields[columnIndex2], new int[]{5, 1, 2, 3, 8, 4});
                }
                return getShortFromString(stringVal, columnIndex2 + 1);
            case 8:
                long valueAsLong2 = getNativeLong(columnIndex2 + 1, false, false);
                if (!f.isUnsigned()) {
                    if (overflowCheck && this.connection.getJdbcCompliantTruncationForReads() && (valueAsLong2 < -32768 || valueAsLong2 > 32767)) {
                        throwRangeException(String.valueOf(valueAsLong2), columnIndex2 + 1, 5);
                    }
                    return (short) valueAsLong2;
                }
                BigInteger asBigInt = convertLongToUlong(valueAsLong2);
                if (overflowCheck && this.connection.getJdbcCompliantTruncationForReads() && (asBigInt.compareTo(new BigInteger(String.valueOf(32767))) > 0 || asBigInt.compareTo(new BigInteger(String.valueOf(-32768))) < 0)) {
                    throwRangeException(asBigInt.toString(), columnIndex2 + 1, 5);
                }
                return (short) getIntFromString(asBigInt.toString(), columnIndex2 + 1);
        }
    }

    protected String getNativeString(int columnIndex) throws SQLException {
        checkRowPos();
        checkColumnBounds(columnIndex);
        if (this.fields == null) {
            throw SQLError.createSQLException(Messages.getString("ResultSet.Query_generated_no_fields_for_ResultSet_133"), SQLError.SQL_STATE_INVALID_COLUMN_NUMBER);
        }
        if (this.thisRow.isNull(columnIndex - 1)) {
            this.wasNullFlag = true;
            return null;
        }
        this.wasNullFlag = false;
        Field field = this.fields[columnIndex - 1];
        String stringVal = getNativeConvertToString(columnIndex, field);
        if (field.isZeroFill() && stringVal != null) {
            int origLength = stringVal.length();
            StringBuffer zeroFillBuf = new StringBuffer(origLength);
            long numZeros = field.getLength() - origLength;
            long j = 0;
            while (true) {
                long i = j;
                if (i >= numZeros) {
                    break;
                }
                zeroFillBuf.append('0');
                j = i + 1;
            }
            zeroFillBuf.append(stringVal);
            stringVal = zeroFillBuf.toString();
        }
        return stringVal;
    }

    private Time getNativeTime(int columnIndex, Calendar targetCalendar, TimeZone tz, boolean rollForward) throws SQLException {
        Time timeVal;
        checkRowPos();
        checkColumnBounds(columnIndex);
        int columnIndexMinusOne = columnIndex - 1;
        int mysqlType = this.fields[columnIndexMinusOne].getMysqlType();
        if (mysqlType == 11) {
            timeVal = this.thisRow.getNativeTime(columnIndexMinusOne, targetCalendar, tz, rollForward, this.connection, this);
        } else {
            timeVal = (Time) this.thisRow.getNativeDateTimeValue(columnIndexMinusOne, null, 92, mysqlType, tz, rollForward, this.connection, this);
        }
        if (timeVal == null) {
            this.wasNullFlag = true;
            return null;
        }
        this.wasNullFlag = false;
        return timeVal;
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    public Time getNativeTimeViaParseConversion(int columnIndex, Calendar targetCalendar, TimeZone tz, boolean rollForward) throws SQLException {
        if (this.useUsageAdvisor) {
            issueConversionViaParsingWarning("getTime()", columnIndex, this.thisRow.getColumnValue(columnIndex - 1), this.fields[columnIndex - 1], new int[]{11});
        }
        String strTime = getNativeString(columnIndex);
        return getTimeFromString(strTime, targetCalendar, columnIndex, tz, rollForward);
    }

    private Timestamp getNativeTimestamp(int columnIndex, Calendar targetCalendar, TimeZone tz, boolean rollForward) throws SQLException {
        Timestamp tsVal;
        checkRowPos();
        checkColumnBounds(columnIndex);
        int columnIndexMinusOne = columnIndex - 1;
        int mysqlType = this.fields[columnIndexMinusOne].getMysqlType();
        switch (mysqlType) {
            case 7:
            case 12:
                tsVal = this.thisRow.getNativeTimestamp(columnIndexMinusOne, targetCalendar, tz, rollForward, this.connection, this);
                break;
            default:
                tsVal = (Timestamp) this.thisRow.getNativeDateTimeValue(columnIndexMinusOne, null, 93, mysqlType, tz, rollForward, this.connection, this);
                break;
        }
        if (tsVal == null) {
            this.wasNullFlag = true;
            return null;
        }
        this.wasNullFlag = false;
        return tsVal;
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    public Timestamp getNativeTimestampViaParseConversion(int columnIndex, Calendar targetCalendar, TimeZone tz, boolean rollForward) throws SQLException {
        if (this.useUsageAdvisor) {
            issueConversionViaParsingWarning("getTimestamp()", columnIndex, this.thisRow.getColumnValue(columnIndex - 1), this.fields[columnIndex - 1], new int[]{7, 12});
        }
        String strTimestamp = getNativeString(columnIndex);
        return getTimestampFromString(columnIndex, targetCalendar, strTimestamp, tz, rollForward);
    }

    protected InputStream getNativeUnicodeStream(int columnIndex) throws SQLException {
        checkRowPos();
        return getBinaryStream(columnIndex);
    }

    protected URL getNativeURL(int colIndex) throws SQLException {
        String val = getString(colIndex);
        if (val == null) {
            return null;
        }
        try {
            return new URL(val);
        } catch (MalformedURLException e) {
            throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("ResultSet.Malformed_URL____141")).append(val).append("'").toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
    }

    @Override // com.mysql.jdbc.ResultSetInternalMethods
    public ResultSetInternalMethods getNextResultSet() {
        return this.nextResultSet;
    }

    @Override // java.sql.ResultSet
    public Object getObject(int columnIndex) throws SQLException {
        checkRowPos();
        checkColumnBounds(columnIndex);
        int columnIndexMinusOne = columnIndex - 1;
        if (this.thisRow.isNull(columnIndexMinusOne)) {
            this.wasNullFlag = true;
            return null;
        }
        this.wasNullFlag = false;
        Field field = this.fields[columnIndexMinusOne];
        switch (field.getSQLType()) {
            case -7:
            case 16:
                if (field.getMysqlType() == 16 && !field.isSingleBit()) {
                    return getBytes(columnIndex);
                }
                return Boolean.valueOf(getBoolean(columnIndex));
            case -6:
                if (!field.isUnsigned()) {
                    return Constants.integerValueOf(getByte(columnIndex));
                }
                return Constants.integerValueOf(getInt(columnIndex));
            case -5:
                if (!field.isUnsigned()) {
                    return Constants.longValueOf(getLong(columnIndex));
                }
                String stringVal = getString(columnIndex);
                if (stringVal == null) {
                    return null;
                }
                try {
                    return new BigInteger(stringVal);
                } catch (NumberFormatException e) {
                    throw SQLError.createSQLException(Messages.getString("ResultSet.Bad_format_for_BigInteger", new Object[]{Constants.integerValueOf(columnIndex), stringVal}), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                }
            case -4:
            case -3:
            case -2:
                if (field.getMysqlType() == 255) {
                    return getBytes(columnIndex);
                }
                if (field.isBinary() || field.isBlob()) {
                    byte[] data = getBytes(columnIndex);
                    if (this.connection.getAutoDeserialize()) {
                        Object obj = data;
                        if (data != null && data.length >= 2) {
                            if (data[0] == -84 && data[1] == -19) {
                                try {
                                    ByteArrayInputStream bytesIn = new ByteArrayInputStream(data);
                                    ObjectInputStream objIn = new ObjectInputStream(bytesIn);
                                    obj = objIn.readObject();
                                    objIn.close();
                                    bytesIn.close();
                                } catch (IOException e2) {
                                    obj = data;
                                } catch (ClassNotFoundException cnfe) {
                                    throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("ResultSet.Class_not_found___91")).append(cnfe.toString()).append(Messages.getString("ResultSet._while_reading_serialized_object_92")).toString());
                                }
                            } else {
                                return getString(columnIndex);
                            }
                        }
                        return obj;
                    }
                    return data;
                }
                return getBytes(columnIndex);
            case -1:
                if (!field.isOpaqueBinary()) {
                    return getStringForClob(columnIndex);
                }
                return getBytes(columnIndex);
            case 1:
            case 12:
                if (!field.isOpaqueBinary()) {
                    return getString(columnIndex);
                }
                return getBytes(columnIndex);
            case 2:
            case 3:
                String stringVal2 = getString(columnIndex);
                if (stringVal2 != null) {
                    if (stringVal2.length() == 0) {
                        BigDecimal val = new BigDecimal(0.0d);
                        return val;
                    }
                    try {
                        BigDecimal val2 = new BigDecimal(stringVal2);
                        return val2;
                    } catch (NumberFormatException e3) {
                        throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("ResultSet.Bad_format_for_BigDecimal____86")).append(stringVal2).append(Messages.getString("ResultSet.___in_column__87")).append(columnIndex).append("(").append(this.fields[columnIndex - 1]).append(").").toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                    }
                }
                return null;
            case 4:
                if (!field.isUnsigned() || field.getMysqlType() == 9) {
                    return Constants.integerValueOf(getInt(columnIndex));
                }
                return Constants.longValueOf(getLong(columnIndex));
            case 5:
                return Constants.integerValueOf(getInt(columnIndex));
            case 6:
            case 8:
                return new Double(getDouble(columnIndex));
            case 7:
                return new Float(getFloat(columnIndex));
            case 91:
                if (field.getMysqlType() == 13 && !this.connection.getYearIsDateType()) {
                    return Constants.shortValueOf(getShort(columnIndex));
                }
                return getDate(columnIndex);
            case 92:
                return getTime(columnIndex);
            case 93:
                return getTimestamp(columnIndex);
            default:
                return getString(columnIndex);
        }
    }

    @Override // java.sql.ResultSet
    public Object getObject(int i, Map map) throws SQLException {
        return getObject(i);
    }

    @Override // java.sql.ResultSet
    public Object getObject(String columnName) throws SQLException {
        return getObject(findColumn(columnName));
    }

    @Override // java.sql.ResultSet
    public Object getObject(String colName, Map map) throws SQLException {
        return getObject(findColumn(colName), map);
    }

    @Override // com.mysql.jdbc.ResultSetInternalMethods
    public Object getObjectStoredProc(int columnIndex, int desiredSqlType) throws SQLException {
        checkRowPos();
        checkColumnBounds(columnIndex);
        Object value = this.thisRow.getColumnValue(columnIndex - 1);
        if (value == null) {
            this.wasNullFlag = true;
            return null;
        }
        this.wasNullFlag = false;
        Field field = this.fields[columnIndex - 1];
        switch (desiredSqlType) {
            case -7:
            case 16:
                return Boolean.valueOf(getBoolean(columnIndex));
            case -6:
                return Constants.integerValueOf(getInt(columnIndex));
            case -5:
                if (field.isUnsigned()) {
                    return getBigDecimal(columnIndex);
                }
                return Constants.longValueOf(getLong(columnIndex));
            case -4:
            case -3:
            case -2:
                return getBytes(columnIndex);
            case -1:
                return getStringForClob(columnIndex);
            case 1:
            case 12:
                return getString(columnIndex);
            case 2:
            case 3:
                String stringVal = getString(columnIndex);
                if (stringVal != null) {
                    if (stringVal.length() == 0) {
                        BigDecimal val = new BigDecimal(0.0d);
                        return val;
                    }
                    try {
                        BigDecimal val2 = new BigDecimal(stringVal);
                        return val2;
                    } catch (NumberFormatException e) {
                        throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("ResultSet.Bad_format_for_BigDecimal____86")).append(stringVal).append(Messages.getString("ResultSet.___in_column__87")).append(columnIndex).append("(").append(this.fields[columnIndex - 1]).append(").").toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                    }
                }
                return null;
            case 4:
                if (!field.isUnsigned() || field.getMysqlType() == 9) {
                    return Constants.integerValueOf(getInt(columnIndex));
                }
                return Constants.longValueOf(getLong(columnIndex));
            case 5:
                return Constants.integerValueOf(getInt(columnIndex));
            case 6:
                if (!this.connection.getRunningCTS13()) {
                    return new Double(getFloat(columnIndex));
                }
                return new Float(getFloat(columnIndex));
            case 7:
                return new Float(getFloat(columnIndex));
            case 8:
                return new Double(getDouble(columnIndex));
            case 91:
                if (field.getMysqlType() == 13 && !this.connection.getYearIsDateType()) {
                    return Constants.shortValueOf(getShort(columnIndex));
                }
                return getDate(columnIndex);
            case 92:
                return getTime(columnIndex);
            case 93:
                return getTimestamp(columnIndex);
            default:
                return getString(columnIndex);
        }
    }

    @Override // com.mysql.jdbc.ResultSetInternalMethods
    public Object getObjectStoredProc(int i, Map map, int desiredSqlType) throws SQLException {
        return getObjectStoredProc(i, desiredSqlType);
    }

    @Override // com.mysql.jdbc.ResultSetInternalMethods
    public Object getObjectStoredProc(String columnName, int desiredSqlType) throws SQLException {
        return getObjectStoredProc(findColumn(columnName), desiredSqlType);
    }

    @Override // com.mysql.jdbc.ResultSetInternalMethods
    public Object getObjectStoredProc(String colName, Map map, int desiredSqlType) throws SQLException {
        return getObjectStoredProc(findColumn(colName), map, desiredSqlType);
    }

    @Override // java.sql.ResultSet
    public Ref getRef(int i) throws SQLException {
        checkColumnBounds(i);
        throw new NotImplemented();
    }

    @Override // java.sql.ResultSet
    public Ref getRef(String colName) throws SQLException {
        return getRef(findColumn(colName));
    }

    @Override // java.sql.ResultSet
    public int getRow() throws SQLException {
        int row;
        checkClosed();
        int currentRowNumber = this.rowData.getCurrentRowNumber();
        if (!this.rowData.isDynamic()) {
            if (currentRowNumber < 0 || this.rowData.isAfterLast() || this.rowData.isEmpty()) {
                row = 0;
            } else {
                row = currentRowNumber + 1;
            }
        } else {
            row = currentRowNumber + 1;
        }
        return row;
    }

    @Override // com.mysql.jdbc.ResultSetInternalMethods
    public String getServerInfo() {
        return this.serverInfo;
    }

    private long getNumericRepresentationOfSQLBitType(int columnIndex) throws SQLException {
        Object value = this.thisRow.getColumnValue(columnIndex - 1);
        if (this.fields[columnIndex - 1].isSingleBit() || ((byte[]) value).length == 1) {
            return ((byte[]) value)[0];
        }
        byte[] asBytes = (byte[]) value;
        int shift = 0;
        long[] steps = new long[asBytes.length];
        for (int i = asBytes.length - 1; i >= 0; i--) {
            steps[i] = (asBytes[i] & 255) << shift;
            shift += 8;
        }
        long valueAsLong = 0;
        for (int i2 = 0; i2 < asBytes.length; i2++) {
            valueAsLong |= steps[i2];
        }
        return valueAsLong;
    }

    @Override // java.sql.ResultSet
    public short getShort(int columnIndex) throws SQLException {
        if (!this.isBinaryEncoded) {
            checkRowPos();
            if (this.connection.getUseFastIntParsing()) {
                checkColumnBounds(columnIndex);
                Object value = this.thisRow.getColumnValue(columnIndex - 1);
                if (value == null) {
                    this.wasNullFlag = true;
                } else {
                    this.wasNullFlag = false;
                }
                if (this.wasNullFlag) {
                    return (short) 0;
                }
                byte[] shortAsBytes = (byte[]) value;
                if (shortAsBytes.length == 0) {
                    return (short) convertToZeroWithEmptyCheck();
                }
                boolean needsFullParse = false;
                for (int i = 0; i < shortAsBytes.length; i++) {
                    if (((char) shortAsBytes[i]) == 'e' || ((char) shortAsBytes[i]) == 'E') {
                        needsFullParse = true;
                        break;
                    }
                }
                if (!needsFullParse) {
                    try {
                        return parseShortWithOverflowCheck(columnIndex, shortAsBytes, null);
                    } catch (NumberFormatException e) {
                        try {
                            return parseShortAsDouble(columnIndex, new String(shortAsBytes));
                        } catch (NumberFormatException e2) {
                            if (this.fields[columnIndex - 1].getMysqlType() == 16) {
                                long valueAsLong = getNumericRepresentationOfSQLBitType(columnIndex);
                                if (this.connection.getJdbcCompliantTruncationForReads() && (valueAsLong < -32768 || valueAsLong > 32767)) {
                                    throwRangeException(String.valueOf(valueAsLong), columnIndex, 5);
                                }
                                return (short) valueAsLong;
                            }
                            throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("ResultSet.Invalid_value_for_getShort()_-____96")).append(new String(shortAsBytes)).append("'").toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                        }
                    }
                }
            }
            try {
                String val = getString(columnIndex);
                if (val != null) {
                    if (val.length() == 0) {
                        return (short) convertToZeroWithEmptyCheck();
                    }
                    if (val.indexOf("e") == -1 && val.indexOf("E") == -1 && val.indexOf(".") == -1) {
                        return parseShortWithOverflowCheck(columnIndex, null, val);
                    }
                    return parseShortAsDouble(columnIndex, val);
                }
                return (short) 0;
            } catch (NumberFormatException e3) {
                try {
                    return parseShortAsDouble(columnIndex, null);
                } catch (NumberFormatException e4) {
                    if (this.fields[columnIndex - 1].getMysqlType() != 16) {
                        throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("ResultSet.Invalid_value_for_getShort()_-____96")).append((String) null).append("'").toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                    }
                    long valueAsLong2 = getNumericRepresentationOfSQLBitType(columnIndex);
                    if (this.connection.getJdbcCompliantTruncationForReads() && (valueAsLong2 < -32768 || valueAsLong2 > 32767)) {
                        throwRangeException(String.valueOf(valueAsLong2), columnIndex, 5);
                    }
                    return (short) valueAsLong2;
                }
            }
        }
        return getNativeShort(columnIndex);
    }

    @Override // java.sql.ResultSet
    public short getShort(String columnName) throws SQLException {
        return getShort(findColumn(columnName));
    }

    private final short getShortFromString(String val, int columnIndex) throws SQLException {
        if (val != null) {
            try {
                if (val.length() == 0) {
                    return (short) convertToZeroWithEmptyCheck();
                }
                if (val.indexOf("e") == -1 && val.indexOf("E") == -1 && val.indexOf(".") == -1) {
                    return parseShortWithOverflowCheck(columnIndex, null, val);
                }
                return parseShortAsDouble(columnIndex, val);
            } catch (NumberFormatException e) {
                try {
                    return parseShortAsDouble(columnIndex, val);
                } catch (NumberFormatException e2) {
                    throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("ResultSet.Invalid_value_for_getShort()_-____217")).append(val).append(Messages.getString("ResultSet.___in_column__218")).append(columnIndex).toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                }
            }
        }
        return (short) 0;
    }

    @Override // java.sql.ResultSet
    public java.sql.Statement getStatement() throws SQLException {
        if (this.isClosed && !this.retainOwningStatement) {
            throw SQLError.createSQLException("Operation not allowed on closed ResultSet. Statements can be retained over result set closure by setting the connection property \"retainStatementAfterResultSetClose\" to \"true\".", SQLError.SQL_STATE_GENERAL_ERROR);
        }
        if (this.wrapperStatement != null) {
            return this.wrapperStatement;
        }
        return this.owningStatement;
    }

    @Override // java.sql.ResultSet
    public String getString(int columnIndex) throws SQLException {
        int fieldLength;
        int currentLength;
        String stringVal = getStringInternal(columnIndex, true);
        if (this.padCharsWithSpace) {
            Field f = this.fields[columnIndex - 1];
            if (f.getMysqlType() == 254 && (currentLength = stringVal.length()) < (fieldLength = ((int) f.getLength()) / f.getMaxBytesPerCharacter())) {
                StringBuffer paddedBuf = new StringBuffer(fieldLength);
                paddedBuf.append(stringVal);
                int difference = fieldLength - currentLength;
                paddedBuf.append(EMPTY_SPACE, 0, difference);
                stringVal = paddedBuf.toString();
            }
        }
        return stringVal;
    }

    @Override // java.sql.ResultSet
    public String getString(String columnName) throws SQLException {
        return getString(findColumn(columnName));
    }

    private String getStringForClob(int columnIndex) throws SQLException {
        byte[] asBytes;
        String asString = null;
        String forcedEncoding = this.connection.getClobCharacterEncoding();
        if (forcedEncoding == null) {
            if (!this.isBinaryEncoded) {
                asString = getString(columnIndex);
            } else {
                asString = getNativeString(columnIndex);
            }
        } else {
            try {
                if (!this.isBinaryEncoded) {
                    asBytes = getBytes(columnIndex);
                } else {
                    asBytes = getNativeBytes(columnIndex, true);
                }
                if (asBytes != null) {
                    asString = new String(asBytes, forcedEncoding);
                }
            } catch (UnsupportedEncodingException e) {
                throw SQLError.createSQLException(new StringBuffer().append("Unsupported character encoding ").append(forcedEncoding).toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
            }
        }
        return asString;
    }

    protected String getStringInternal(int columnIndex, boolean checkDateTypes) throws SQLException {
        if (!this.isBinaryEncoded) {
            checkRowPos();
            checkColumnBounds(columnIndex);
            if (this.fields == null) {
                throw SQLError.createSQLException(Messages.getString("ResultSet.Query_generated_no_fields_for_ResultSet_99"), SQLError.SQL_STATE_INVALID_COLUMN_NUMBER);
            }
            int internalColumnIndex = columnIndex - 1;
            if (this.thisRow.isNull(internalColumnIndex)) {
                this.wasNullFlag = true;
                return null;
            }
            this.wasNullFlag = false;
            Field metadata = this.fields[internalColumnIndex];
            if (metadata.getMysqlType() == 16) {
                if (metadata.isSingleBit()) {
                    byte[] value = this.thisRow.getColumnValue(internalColumnIndex);
                    if (value.length == 0) {
                        return String.valueOf(convertToZeroWithEmptyCheck());
                    }
                    return String.valueOf((int) value[0]);
                }
                return String.valueOf(getNumericRepresentationOfSQLBitType(columnIndex));
            }
            String encoding = metadata.getCharacterSet();
            String stringVal = this.thisRow.getString(internalColumnIndex, encoding, this.connection);
            if (metadata.getMysqlType() == 13) {
                if (!this.connection.getYearIsDateType()) {
                    return stringVal;
                }
                Date dt = getDateFromString(stringVal, columnIndex);
                if (dt == null) {
                    this.wasNullFlag = true;
                    return null;
                }
                this.wasNullFlag = false;
                return dt.toString();
            }
            if (checkDateTypes && !this.connection.getNoDatetimeStringSync()) {
                switch (metadata.getSQLType()) {
                    case 91:
                        Date dt2 = getDateFromString(stringVal, columnIndex);
                        if (dt2 == null) {
                            this.wasNullFlag = true;
                            return null;
                        }
                        this.wasNullFlag = false;
                        return dt2.toString();
                    case 92:
                        Time tm = getTimeFromString(stringVal, null, columnIndex, getDefaultTimeZone(), false);
                        if (tm == null) {
                            this.wasNullFlag = true;
                            return null;
                        }
                        this.wasNullFlag = false;
                        return tm.toString();
                    case 93:
                        Timestamp ts = getTimestampFromString(columnIndex, null, stringVal, getDefaultTimeZone(), false);
                        if (ts == null) {
                            this.wasNullFlag = true;
                            return null;
                        }
                        this.wasNullFlag = false;
                        return ts.toString();
                }
            }
            return stringVal;
        }
        return getNativeString(columnIndex);
    }

    @Override // java.sql.ResultSet
    public Time getTime(int columnIndex) throws SQLException {
        return getTimeInternal(columnIndex, null, getDefaultTimeZone(), false);
    }

    @Override // java.sql.ResultSet
    public Time getTime(int columnIndex, Calendar cal) throws SQLException {
        return getTimeInternal(columnIndex, cal, cal.getTimeZone(), true);
    }

    @Override // java.sql.ResultSet
    public Time getTime(String columnName) throws SQLException {
        return getTime(findColumn(columnName));
    }

    @Override // java.sql.ResultSet
    public Time getTime(String columnName, Calendar cal) throws SQLException {
        return getTime(findColumn(columnName), cal);
    }

    private Time getTimeFromString(String timeAsString, Calendar targetCalendar, int columnIndex, TimeZone tz, boolean rollForward) throws SQLException {
        int hr;
        int min;
        int sec;
        Time changeTimezone;
        try {
            if (timeAsString == null) {
                this.wasNullFlag = true;
                return null;
            }
            String timeAsString2 = timeAsString.trim();
            if (timeAsString2.equals("0") || timeAsString2.equals("0000-00-00") || timeAsString2.equals("0000-00-00 00:00:00") || timeAsString2.equals("00000000000000")) {
                if ("convertToNull".equals(this.connection.getZeroDateTimeBehavior())) {
                    this.wasNullFlag = true;
                    return null;
                }
                if ("exception".equals(this.connection.getZeroDateTimeBehavior())) {
                    throw SQLError.createSQLException(new StringBuffer().append("Value '").append(timeAsString2).append("' can not be represented as java.sql.Time").toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                }
                return fastTimeCreate(null, 0, 0, 0);
            }
            this.wasNullFlag = false;
            Field timeColField = this.fields[columnIndex - 1];
            if (timeColField.getMysqlType() == 7) {
                int length = timeAsString2.length();
                switch (length) {
                    case 10:
                        hr = Integer.parseInt(timeAsString2.substring(6, 8));
                        min = Integer.parseInt(timeAsString2.substring(8, 10));
                        sec = 0;
                        break;
                    case 11:
                    case 13:
                    case 15:
                    case 16:
                    case 17:
                    case 18:
                    default:
                        throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("ResultSet.Timestamp_too_small_to_convert_to_Time_value_in_column__257")).append(columnIndex).append("(").append(this.fields[columnIndex - 1]).append(").").toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                    case 12:
                    case 14:
                        hr = Integer.parseInt(timeAsString2.substring(length - 6, length - 4));
                        min = Integer.parseInt(timeAsString2.substring(length - 4, length - 2));
                        sec = Integer.parseInt(timeAsString2.substring(length - 2, length));
                        break;
                    case 19:
                        hr = Integer.parseInt(timeAsString2.substring(length - 8, length - 6));
                        min = Integer.parseInt(timeAsString2.substring(length - 5, length - 3));
                        sec = Integer.parseInt(timeAsString2.substring(length - 2, length));
                        break;
                }
                SQLWarning precisionLost = new SQLWarning(new StringBuffer().append(Messages.getString("ResultSet.Precision_lost_converting_TIMESTAMP_to_Time_with_getTime()_on_column__261")).append(columnIndex).append("(").append(this.fields[columnIndex - 1]).append(").").toString());
                if (this.warningChain == null) {
                    this.warningChain = precisionLost;
                } else {
                    this.warningChain.setNextWarning(precisionLost);
                }
            } else if (timeColField.getMysqlType() == 12) {
                hr = Integer.parseInt(timeAsString2.substring(11, 13));
                min = Integer.parseInt(timeAsString2.substring(14, 16));
                sec = Integer.parseInt(timeAsString2.substring(17, 19));
                SQLWarning precisionLost2 = new SQLWarning(new StringBuffer().append(Messages.getString("ResultSet.Precision_lost_converting_DATETIME_to_Time_with_getTime()_on_column__264")).append(columnIndex).append("(").append(this.fields[columnIndex - 1]).append(").").toString());
                if (this.warningChain == null) {
                    this.warningChain = precisionLost2;
                } else {
                    this.warningChain.setNextWarning(precisionLost2);
                }
            } else {
                if (timeColField.getMysqlType() == 10) {
                    return fastTimeCreate(null, 0, 0, 0);
                }
                if (timeAsString2.length() != 5 && timeAsString2.length() != 8) {
                    throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("ResultSet.Bad_format_for_Time____267")).append(timeAsString2).append(Messages.getString("ResultSet.___in_column__268")).append(columnIndex).toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                }
                hr = Integer.parseInt(timeAsString2.substring(0, 2));
                min = Integer.parseInt(timeAsString2.substring(3, 5));
                sec = timeAsString2.length() == 5 ? 0 : Integer.parseInt(timeAsString2.substring(6));
            }
            Calendar sessionCalendar = getCalendarInstanceForSessionOrNew();
            synchronized (sessionCalendar) {
                changeTimezone = TimeUtil.changeTimezone(this.connection, sessionCalendar, targetCalendar, fastTimeCreate(sessionCalendar, hr, min, sec), this.connection.getServerTimezoneTZ(), tz, rollForward);
            }
            return changeTimezone;
        } catch (Exception ex) {
            throw SQLError.createSQLException(ex.toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
    }

    private Time getTimeInternal(int columnIndex, Calendar targetCalendar, TimeZone tz, boolean rollForward) throws SQLException {
        if (this.isBinaryEncoded) {
            return getNativeTime(columnIndex, targetCalendar, tz, rollForward);
        }
        if (!this.useFastDateParsing) {
            String timeAsString = getStringInternal(columnIndex, false);
            return getTimeFromString(timeAsString, targetCalendar, columnIndex, tz, rollForward);
        }
        checkColumnBounds(columnIndex);
        int columnIndexMinusOne = columnIndex - 1;
        if (this.thisRow.isNull(columnIndexMinusOne)) {
            this.wasNullFlag = true;
            return null;
        }
        this.wasNullFlag = false;
        return this.thisRow.getTimeFast(columnIndexMinusOne, targetCalendar, tz, rollForward, this.connection, this);
    }

    @Override // java.sql.ResultSet
    public Timestamp getTimestamp(int columnIndex) throws SQLException {
        checkColumnBounds(columnIndex);
        return getTimestampInternal(columnIndex, null, getDefaultTimeZone(), false);
    }

    @Override // java.sql.ResultSet
    public Timestamp getTimestamp(int columnIndex, Calendar cal) throws SQLException {
        return getTimestampInternal(columnIndex, cal, cal.getTimeZone(), true);
    }

    @Override // java.sql.ResultSet
    public Timestamp getTimestamp(String columnName) throws SQLException {
        return getTimestamp(findColumn(columnName));
    }

    @Override // java.sql.ResultSet
    public Timestamp getTimestamp(String columnName, Calendar cal) throws SQLException {
        return getTimestamp(findColumn(columnName), cal);
    }

    private Timestamp getTimestampFromString(int columnIndex, Calendar targetCalendar, String timestampValue, TimeZone tz, boolean rollForward) throws SQLException {
        int year;
        int month;
        int day;
        int hour;
        int minutes;
        int decimalIndex;
        try {
            this.wasNullFlag = false;
            if (timestampValue == null) {
                this.wasNullFlag = true;
                return null;
            }
            timestampValue = timestampValue.trim();
            int length = timestampValue.length();
            Calendar sessionCalendar = this.connection.getUseJDBCCompliantTimezoneShift() ? this.connection.getUtcCalendar() : getCalendarInstanceForSessionOrNew();
            synchronized (sessionCalendar) {
                if (length > 0) {
                    if (timestampValue.charAt(0) == '0' && (timestampValue.equals("0000-00-00") || timestampValue.equals("0000-00-00 00:00:00") || timestampValue.equals("00000000000000") || timestampValue.equals("0"))) {
                        if ("convertToNull".equals(this.connection.getZeroDateTimeBehavior())) {
                            this.wasNullFlag = true;
                            return null;
                        }
                        if ("exception".equals(this.connection.getZeroDateTimeBehavior())) {
                            throw SQLError.createSQLException(new StringBuffer().append("Value '").append(timestampValue).append("' can not be represented as java.sql.Timestamp").toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                        }
                        return fastTimestampCreate(null, 1, 1, 1, 0, 0, 0, 0);
                    }
                }
                if (this.fields[columnIndex - 1].getMysqlType() == 13) {
                    return TimeUtil.changeTimezone(this.connection, sessionCalendar, targetCalendar, fastTimestampCreate(sessionCalendar, Integer.parseInt(timestampValue.substring(0, 4)), 1, 1, 0, 0, 0, 0), this.connection.getServerTimezoneTZ(), tz, rollForward);
                }
                if (timestampValue.endsWith(".")) {
                    timestampValue = timestampValue.substring(0, timestampValue.length() - 1);
                }
                switch (length) {
                    case 2:
                        int year2 = Integer.parseInt(timestampValue.substring(0, 2));
                        if (year2 <= 69) {
                            year2 += 100;
                        }
                        return TimeUtil.changeTimezone(this.connection, sessionCalendar, targetCalendar, fastTimestampCreate(null, year2 + 1900, 1, 1, 0, 0, 0, 0), this.connection.getServerTimezoneTZ(), tz, rollForward);
                    case 3:
                    case 5:
                    case 7:
                    case 9:
                    case 11:
                    case 13:
                    case 15:
                    case 16:
                    case 17:
                    case 18:
                    default:
                        throw new SQLException(new StringBuffer().append("Bad format for Timestamp '").append(timestampValue).append("' in column ").append(columnIndex).append(".").toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                    case 4:
                        int year3 = Integer.parseInt(timestampValue.substring(0, 2));
                        if (year3 <= 69) {
                            year3 += 100;
                        }
                        int month2 = Integer.parseInt(timestampValue.substring(2, 4));
                        return TimeUtil.changeTimezone(this.connection, sessionCalendar, targetCalendar, fastTimestampCreate(sessionCalendar, year3 + 1900, month2, 1, 0, 0, 0, 0), this.connection.getServerTimezoneTZ(), tz, rollForward);
                    case 6:
                        int year4 = Integer.parseInt(timestampValue.substring(0, 2));
                        if (year4 <= 69) {
                            year4 += 100;
                        }
                        int month3 = Integer.parseInt(timestampValue.substring(2, 4));
                        int day2 = Integer.parseInt(timestampValue.substring(4, 6));
                        return TimeUtil.changeTimezone(this.connection, sessionCalendar, targetCalendar, fastTimestampCreate(sessionCalendar, year4 + 1900, month3, day2, 0, 0, 0, 0), this.connection.getServerTimezoneTZ(), tz, rollForward);
                    case 8:
                        if (timestampValue.indexOf(":") != -1) {
                            int hour2 = Integer.parseInt(timestampValue.substring(0, 2));
                            int minutes2 = Integer.parseInt(timestampValue.substring(3, 5));
                            int seconds = Integer.parseInt(timestampValue.substring(6, 8));
                            return TimeUtil.changeTimezone(this.connection, sessionCalendar, targetCalendar, fastTimestampCreate(sessionCalendar, 1970, 1, 1, hour2, minutes2, seconds, 0), this.connection.getServerTimezoneTZ(), tz, rollForward);
                        }
                        int year5 = Integer.parseInt(timestampValue.substring(0, 4));
                        int month4 = Integer.parseInt(timestampValue.substring(4, 6));
                        int day3 = Integer.parseInt(timestampValue.substring(6, 8));
                        return TimeUtil.changeTimezone(this.connection, sessionCalendar, targetCalendar, fastTimestampCreate(sessionCalendar, year5 - 1900, month4 - 1, day3, 0, 0, 0, 0), this.connection.getServerTimezoneTZ(), tz, rollForward);
                    case 10:
                        if (this.fields[columnIndex - 1].getMysqlType() == 10 || timestampValue.indexOf("-") != -1) {
                            year = Integer.parseInt(timestampValue.substring(0, 4));
                            month = Integer.parseInt(timestampValue.substring(5, 7));
                            day = Integer.parseInt(timestampValue.substring(8, 10));
                            hour = 0;
                            minutes = 0;
                        } else {
                            int year6 = Integer.parseInt(timestampValue.substring(0, 2));
                            if (year6 <= 69) {
                                year6 += 100;
                            }
                            month = Integer.parseInt(timestampValue.substring(2, 4));
                            day = Integer.parseInt(timestampValue.substring(4, 6));
                            hour = Integer.parseInt(timestampValue.substring(6, 8));
                            minutes = Integer.parseInt(timestampValue.substring(8, 10));
                            year = year6 + 1900;
                        }
                        return TimeUtil.changeTimezone(this.connection, sessionCalendar, targetCalendar, fastTimestampCreate(sessionCalendar, year, month, day, hour, minutes, 0, 0), this.connection.getServerTimezoneTZ(), tz, rollForward);
                    case 12:
                        int year7 = Integer.parseInt(timestampValue.substring(0, 2));
                        if (year7 <= 69) {
                            year7 += 100;
                        }
                        int month5 = Integer.parseInt(timestampValue.substring(2, 4));
                        int day4 = Integer.parseInt(timestampValue.substring(4, 6));
                        int hour3 = Integer.parseInt(timestampValue.substring(6, 8));
                        int minutes3 = Integer.parseInt(timestampValue.substring(8, 10));
                        int seconds2 = Integer.parseInt(timestampValue.substring(10, 12));
                        return TimeUtil.changeTimezone(this.connection, sessionCalendar, targetCalendar, fastTimestampCreate(sessionCalendar, year7 + 1900, month5, day4, hour3, minutes3, seconds2, 0), this.connection.getServerTimezoneTZ(), tz, rollForward);
                    case 14:
                        int year8 = Integer.parseInt(timestampValue.substring(0, 4));
                        int month6 = Integer.parseInt(timestampValue.substring(4, 6));
                        int day5 = Integer.parseInt(timestampValue.substring(6, 8));
                        int hour4 = Integer.parseInt(timestampValue.substring(8, 10));
                        int minutes4 = Integer.parseInt(timestampValue.substring(10, 12));
                        int seconds3 = Integer.parseInt(timestampValue.substring(12, 14));
                        return TimeUtil.changeTimezone(this.connection, sessionCalendar, targetCalendar, fastTimestampCreate(sessionCalendar, year8, month6, day5, hour4, minutes4, seconds3, 0), this.connection.getServerTimezoneTZ(), tz, rollForward);
                    case 19:
                    case 20:
                    case 21:
                    case 22:
                    case 23:
                    case 24:
                    case 25:
                    case 26:
                        int year9 = Integer.parseInt(timestampValue.substring(0, 4));
                        int month7 = Integer.parseInt(timestampValue.substring(5, 7));
                        int day6 = Integer.parseInt(timestampValue.substring(8, 10));
                        int hour5 = Integer.parseInt(timestampValue.substring(11, 13));
                        int minutes5 = Integer.parseInt(timestampValue.substring(14, 16));
                        int seconds4 = Integer.parseInt(timestampValue.substring(17, 19));
                        int nanos = 0;
                        if (length > 19 && (decimalIndex = timestampValue.lastIndexOf(46)) != -1) {
                            if (decimalIndex + 2 <= timestampValue.length()) {
                                nanos = Integer.parseInt(timestampValue.substring(decimalIndex + 1));
                            } else {
                                throw new IllegalArgumentException();
                            }
                        }
                        return TimeUtil.changeTimezone(this.connection, sessionCalendar, targetCalendar, fastTimestampCreate(sessionCalendar, year9, month7, day6, hour5, minutes5, seconds4, nanos), this.connection.getServerTimezoneTZ(), tz, rollForward);
                }
            }
        } catch (Exception e) {
            throw new SQLException(new StringBuffer().append("Cannot convert value '").append(timestampValue).append("' from column ").append(columnIndex).append(" to TIMESTAMP.").toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
    }

    private Timestamp getTimestampFromBytes(int columnIndex, Calendar targetCalendar, byte[] timestampAsBytes, TimeZone tz, boolean rollForward) throws SQLException {
        int year;
        int month;
        int day;
        int hour;
        int minutes;
        int decimalIndex;
        checkColumnBounds(columnIndex);
        try {
            this.wasNullFlag = false;
            if (timestampAsBytes == null) {
                this.wasNullFlag = true;
                return null;
            }
            int length = timestampAsBytes.length;
            Calendar sessionCalendar = this.connection.getUseJDBCCompliantTimezoneShift() ? this.connection.getUtcCalendar() : getCalendarInstanceForSessionOrNew();
            synchronized (sessionCalendar) {
                boolean allZeroTimestamp = true;
                boolean onlyTimePresent = StringUtils.indexOf(timestampAsBytes, ':') != -1;
                int i = 0;
                while (true) {
                    if (i < length) {
                        byte b = timestampAsBytes[i];
                        if (b == 32 || b == 45 || b == 47) {
                            onlyTimePresent = false;
                        }
                        if (b == 48 || b == 32 || b == 58 || b == 45 || b == 47 || b == 46) {
                            i++;
                        } else {
                            allZeroTimestamp = false;
                            break;
                        }
                    } else {
                        break;
                    }
                }
                if (!onlyTimePresent && allZeroTimestamp) {
                    if ("convertToNull".equals(this.connection.getZeroDateTimeBehavior())) {
                        this.wasNullFlag = true;
                        return null;
                    }
                    if ("exception".equals(this.connection.getZeroDateTimeBehavior())) {
                        throw SQLError.createSQLException(new StringBuffer().append("Value '").append(timestampAsBytes).append("' can not be represented as java.sql.Timestamp").toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                    }
                    return fastTimestampCreate(null, 1, 1, 1, 0, 0, 0, 0);
                }
                if (this.fields[columnIndex - 1].getMysqlType() == 13) {
                    return TimeUtil.changeTimezone(this.connection, sessionCalendar, targetCalendar, fastTimestampCreate(sessionCalendar, StringUtils.getInt(timestampAsBytes, 0, 4), 1, 1, 0, 0, 0, 0), this.connection.getServerTimezoneTZ(), tz, rollForward);
                }
                if (timestampAsBytes[length - 1] == 46) {
                    length--;
                }
                switch (length) {
                    case 2:
                        int year2 = StringUtils.getInt(timestampAsBytes, 0, 2);
                        if (year2 <= 69) {
                            year2 += 100;
                        }
                        return TimeUtil.changeTimezone(this.connection, sessionCalendar, targetCalendar, fastTimestampCreate(null, year2 + 1900, 1, 1, 0, 0, 0, 0), this.connection.getServerTimezoneTZ(), tz, rollForward);
                    case 3:
                    case 5:
                    case 7:
                    case 9:
                    case 11:
                    case 13:
                    case 15:
                    case 16:
                    case 17:
                    case 18:
                    default:
                        throw new SQLException(new StringBuffer().append("Bad format for Timestamp '").append(new String(timestampAsBytes)).append("' in column ").append(columnIndex).append(".").toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
                    case 4:
                        int year3 = StringUtils.getInt(timestampAsBytes, 0, 2);
                        if (year3 <= 69) {
                            year3 += 100;
                        }
                        int month2 = StringUtils.getInt(timestampAsBytes, 2, 4);
                        return TimeUtil.changeTimezone(this.connection, sessionCalendar, targetCalendar, fastTimestampCreate(sessionCalendar, year3 + 1900, month2, 1, 0, 0, 0, 0), this.connection.getServerTimezoneTZ(), tz, rollForward);
                    case 6:
                        int year4 = StringUtils.getInt(timestampAsBytes, 0, 2);
                        if (year4 <= 69) {
                            year4 += 100;
                        }
                        int month3 = StringUtils.getInt(timestampAsBytes, 2, 4);
                        int day2 = StringUtils.getInt(timestampAsBytes, 4, 6);
                        return TimeUtil.changeTimezone(this.connection, sessionCalendar, targetCalendar, fastTimestampCreate(sessionCalendar, year4 + 1900, month3, day2, 0, 0, 0, 0), this.connection.getServerTimezoneTZ(), tz, rollForward);
                    case 8:
                        if (StringUtils.indexOf(timestampAsBytes, ':') != -1) {
                            int hour2 = StringUtils.getInt(timestampAsBytes, 0, 2);
                            int minutes2 = StringUtils.getInt(timestampAsBytes, 3, 5);
                            int seconds = StringUtils.getInt(timestampAsBytes, 6, 8);
                            return TimeUtil.changeTimezone(this.connection, sessionCalendar, targetCalendar, fastTimestampCreate(sessionCalendar, 1970, 1, 1, hour2, minutes2, seconds, 0), this.connection.getServerTimezoneTZ(), tz, rollForward);
                        }
                        int year5 = StringUtils.getInt(timestampAsBytes, 0, 4);
                        int month4 = StringUtils.getInt(timestampAsBytes, 4, 6);
                        int day3 = StringUtils.getInt(timestampAsBytes, 6, 8);
                        return TimeUtil.changeTimezone(this.connection, sessionCalendar, targetCalendar, fastTimestampCreate(sessionCalendar, year5 - 1900, month4 - 1, day3, 0, 0, 0, 0), this.connection.getServerTimezoneTZ(), tz, rollForward);
                    case 10:
                        if (this.fields[columnIndex - 1].getMysqlType() == 10 || StringUtils.indexOf(timestampAsBytes, '-') != -1) {
                            year = StringUtils.getInt(timestampAsBytes, 0, 4);
                            month = StringUtils.getInt(timestampAsBytes, 5, 7);
                            day = StringUtils.getInt(timestampAsBytes, 8, 10);
                            hour = 0;
                            minutes = 0;
                        } else {
                            int year6 = StringUtils.getInt(timestampAsBytes, 0, 2);
                            if (year6 <= 69) {
                                year6 += 100;
                            }
                            month = StringUtils.getInt(timestampAsBytes, 2, 4);
                            day = StringUtils.getInt(timestampAsBytes, 4, 6);
                            hour = StringUtils.getInt(timestampAsBytes, 6, 8);
                            minutes = StringUtils.getInt(timestampAsBytes, 8, 10);
                            year = year6 + 1900;
                        }
                        return TimeUtil.changeTimezone(this.connection, sessionCalendar, targetCalendar, fastTimestampCreate(sessionCalendar, year, month, day, hour, minutes, 0, 0), this.connection.getServerTimezoneTZ(), tz, rollForward);
                    case 12:
                        int year7 = StringUtils.getInt(timestampAsBytes, 0, 2);
                        if (year7 <= 69) {
                            year7 += 100;
                        }
                        int month5 = StringUtils.getInt(timestampAsBytes, 2, 4);
                        int day4 = StringUtils.getInt(timestampAsBytes, 4, 6);
                        int hour3 = StringUtils.getInt(timestampAsBytes, 6, 8);
                        int minutes3 = StringUtils.getInt(timestampAsBytes, 8, 10);
                        int seconds2 = StringUtils.getInt(timestampAsBytes, 10, 12);
                        return TimeUtil.changeTimezone(this.connection, sessionCalendar, targetCalendar, fastTimestampCreate(sessionCalendar, year7 + 1900, month5, day4, hour3, minutes3, seconds2, 0), this.connection.getServerTimezoneTZ(), tz, rollForward);
                    case 14:
                        int year8 = StringUtils.getInt(timestampAsBytes, 0, 4);
                        int month6 = StringUtils.getInt(timestampAsBytes, 4, 6);
                        int day5 = StringUtils.getInt(timestampAsBytes, 6, 8);
                        int hour4 = StringUtils.getInt(timestampAsBytes, 8, 10);
                        int minutes4 = StringUtils.getInt(timestampAsBytes, 10, 12);
                        int seconds3 = StringUtils.getInt(timestampAsBytes, 12, 14);
                        return TimeUtil.changeTimezone(this.connection, sessionCalendar, targetCalendar, fastTimestampCreate(sessionCalendar, year8, month6, day5, hour4, minutes4, seconds3, 0), this.connection.getServerTimezoneTZ(), tz, rollForward);
                    case 19:
                    case 20:
                    case 21:
                    case 22:
                    case 23:
                    case 24:
                    case 25:
                    case 26:
                        int year9 = StringUtils.getInt(timestampAsBytes, 0, 4);
                        int month7 = StringUtils.getInt(timestampAsBytes, 5, 7);
                        int day6 = StringUtils.getInt(timestampAsBytes, 8, 10);
                        int hour5 = StringUtils.getInt(timestampAsBytes, 11, 13);
                        int minutes5 = StringUtils.getInt(timestampAsBytes, 14, 16);
                        int seconds4 = StringUtils.getInt(timestampAsBytes, 17, 19);
                        int nanos = 0;
                        if (length > 19 && (decimalIndex = StringUtils.lastIndexOf(timestampAsBytes, '.')) != -1) {
                            if (decimalIndex + 2 <= length) {
                                nanos = StringUtils.getInt(timestampAsBytes, decimalIndex + 1, length);
                            } else {
                                throw new IllegalArgumentException();
                            }
                        }
                        return TimeUtil.changeTimezone(this.connection, sessionCalendar, targetCalendar, fastTimestampCreate(sessionCalendar, year9, month7, day6, hour5, minutes5, seconds4, nanos), this.connection.getServerTimezoneTZ(), tz, rollForward);
                }
            }
        } catch (Exception e) {
            throw new SQLException(new StringBuffer().append("Cannot convert value '").append(new String(timestampAsBytes)).append("' from column ").append(columnIndex).append(" to TIMESTAMP.").toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
    }

    private Timestamp getTimestampInternal(int columnIndex, Calendar targetCalendar, TimeZone tz, boolean rollForward) throws SQLException {
        Timestamp tsVal;
        if (this.isBinaryEncoded) {
            return getNativeTimestamp(columnIndex, targetCalendar, tz, rollForward);
        }
        if (!this.useFastDateParsing) {
            String timestampValue = getStringInternal(columnIndex, false);
            tsVal = getTimestampFromString(columnIndex, targetCalendar, timestampValue, tz, rollForward);
        } else {
            tsVal = this.thisRow.getTimestampFast(columnIndex - 1, targetCalendar, tz, rollForward, this.connection, this);
        }
        if (tsVal == null) {
            this.wasNullFlag = true;
        } else {
            this.wasNullFlag = false;
        }
        return tsVal;
    }

    @Override // java.sql.ResultSet
    public int getType() throws SQLException {
        return this.resultSetType;
    }

    @Override // java.sql.ResultSet
    public InputStream getUnicodeStream(int columnIndex) throws SQLException {
        if (!this.isBinaryEncoded) {
            checkRowPos();
            return getBinaryStream(columnIndex);
        }
        return getNativeBinaryStream(columnIndex);
    }

    @Override // java.sql.ResultSet
    public InputStream getUnicodeStream(String columnName) throws SQLException {
        return getUnicodeStream(findColumn(columnName));
    }

    @Override // com.mysql.jdbc.ResultSetInternalMethods
    public long getUpdateCount() {
        return this.updateCount;
    }

    @Override // com.mysql.jdbc.ResultSetInternalMethods
    public long getUpdateID() {
        return this.updateId;
    }

    @Override // java.sql.ResultSet
    public URL getURL(int colIndex) throws SQLException {
        String val = getString(colIndex);
        if (val == null) {
            return null;
        }
        try {
            return new URL(val);
        } catch (MalformedURLException e) {
            throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("ResultSet.Malformed_URL____104")).append(val).append("'").toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
    }

    @Override // java.sql.ResultSet
    public URL getURL(String colName) throws SQLException {
        String val = getString(colName);
        if (val == null) {
            return null;
        }
        try {
            return new URL(val);
        } catch (MalformedURLException e) {
            throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("ResultSet.Malformed_URL____107")).append(val).append("'").toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
    }

    @Override // java.sql.ResultSet
    public SQLWarning getWarnings() throws SQLException {
        return this.warningChain;
    }

    @Override // java.sql.ResultSet
    public void insertRow() throws SQLException {
        throw new NotUpdatable();
    }

    @Override // java.sql.ResultSet
    public boolean isAfterLast() throws SQLException {
        checkClosed();
        boolean b = this.rowData.isAfterLast();
        return b;
    }

    @Override // java.sql.ResultSet
    public boolean isBeforeFirst() throws SQLException {
        checkClosed();
        return this.rowData.isBeforeFirst();
    }

    @Override // java.sql.ResultSet
    public boolean isFirst() throws SQLException {
        checkClosed();
        return this.rowData.isFirst();
    }

    @Override // java.sql.ResultSet
    public boolean isLast() throws SQLException {
        checkClosed();
        return this.rowData.isLast();
    }

    private void issueConversionViaParsingWarning(String methodName, int columnIndex, Object value, Field fieldInfo, int[] typesWithNoParseConversion) throws SQLException {
        StringBuffer originalQueryBuf = new StringBuffer();
        if (this.owningStatement != null && (this.owningStatement instanceof PreparedStatement)) {
            originalQueryBuf.append(Messages.getString("ResultSet.CostlyConversionCreatedFromQuery"));
            originalQueryBuf.append(((PreparedStatement) this.owningStatement).originalSql);
            originalQueryBuf.append("\n\n");
        } else {
            originalQueryBuf.append(".");
        }
        StringBuffer convertibleTypesBuf = new StringBuffer();
        for (int i : typesWithNoParseConversion) {
            convertibleTypesBuf.append(MysqlDefs.typeToName(i));
            convertibleTypesBuf.append("\n");
        }
        Object[] objArr = new Object[8];
        objArr[0] = methodName;
        objArr[1] = new Integer(columnIndex + 1);
        objArr[2] = fieldInfo.getOriginalName();
        objArr[3] = fieldInfo.getOriginalTableName();
        objArr[4] = originalQueryBuf.toString();
        objArr[5] = value != null ? value.getClass().getName() : ResultSetMetaData.getClassNameForJavaType(fieldInfo.getSQLType(), fieldInfo.isUnsigned(), fieldInfo.getMysqlType(), fieldInfo.isBinary() || fieldInfo.isBlob(), fieldInfo.isOpaqueBinary());
        objArr[6] = MysqlDefs.typeToName(fieldInfo.getMysqlType());
        objArr[7] = convertibleTypesBuf.toString();
        String message = Messages.getString("ResultSet.CostlyConversion", objArr);
        this.eventSink.consumeEvent(new ProfilerEvent((byte) 0, "", this.owningStatement == null ? "N/A" : this.owningStatement.currentCatalog, this.connectionId, this.owningStatement == null ? -1 : this.owningStatement.getId(), this.resultId, System.currentTimeMillis(), 0L, Constants.MILLIS_I18N, (String) null, this.pointOfOrigin, message));
    }

    @Override // java.sql.ResultSet
    public boolean last() throws SQLException {
        checkClosed();
        if (this.rowData.size() == 0) {
            return false;
        }
        if (this.onInsertRow) {
            this.onInsertRow = false;
        }
        if (this.doingUpdates) {
            this.doingUpdates = false;
        }
        if (this.thisRow != null) {
            this.thisRow.closeOpenStreams();
        }
        this.rowData.beforeLast();
        this.thisRow = this.rowData.next();
        return true;
    }

    @Override // java.sql.ResultSet
    public void moveToCurrentRow() throws SQLException {
        throw new NotUpdatable();
    }

    @Override // java.sql.ResultSet
    public void moveToInsertRow() throws SQLException {
        throw new NotUpdatable();
    }

    @Override // java.sql.ResultSet
    public boolean next() throws SQLException {
        boolean b;
        checkClosed();
        if (this.onInsertRow) {
            this.onInsertRow = false;
        }
        if (this.doingUpdates) {
            this.doingUpdates = false;
        }
        if (!reallyResult()) {
            throw SQLError.createSQLException(Messages.getString("ResultSet.ResultSet_is_from_UPDATE._No_Data_115"), SQLError.SQL_STATE_GENERAL_ERROR);
        }
        if (this.thisRow != null) {
            this.thisRow.closeOpenStreams();
        }
        if (this.rowData.size() == 0) {
            b = false;
        } else {
            this.thisRow = this.rowData.next();
            if (this.thisRow == null) {
                b = false;
            } else {
                clearWarnings();
                b = true;
            }
        }
        return b;
    }

    private int parseIntAsDouble(int columnIndex, String val) throws NumberFormatException, SQLException {
        if (val == null) {
            return 0;
        }
        double valueAsDouble = Double.parseDouble(val);
        if (this.connection.getJdbcCompliantTruncationForReads() && (valueAsDouble < -2.147483648E9d || valueAsDouble > 2.147483647E9d)) {
            throwRangeException(String.valueOf(valueAsDouble), columnIndex, 4);
        }
        return (int) valueAsDouble;
    }

    private int getIntWithOverflowCheck(int columnIndex) throws SQLException {
        int intValue = this.thisRow.getInt(columnIndex);
        checkForIntegerTruncation(columnIndex + 1, null, this.thisRow.getString(columnIndex, this.fields[columnIndex].getCharacterSet(), this.connection), intValue);
        return intValue;
    }

    private void checkForIntegerTruncation(int columnIndex, byte[] valueAsBytes, String valueAsString, int intValue) throws SQLException {
        if (this.connection.getJdbcCompliantTruncationForReads()) {
            if (intValue == Integer.MIN_VALUE || intValue == Integer.MAX_VALUE) {
                long valueAsLong = Long.parseLong(valueAsString == null ? new String(valueAsBytes) : valueAsString);
                if (valueAsLong < -2147483648L || valueAsLong > 2147483647L) {
                    throwRangeException(valueAsString == null ? new String(valueAsBytes) : valueAsString, columnIndex, 4);
                }
            }
        }
    }

    private long parseLongAsDouble(int columnIndex, String val) throws NumberFormatException, SQLException {
        if (val == null) {
            return 0L;
        }
        double valueAsDouble = Double.parseDouble(val);
        if (this.connection.getJdbcCompliantTruncationForReads() && (valueAsDouble < -9.223372036854776E18d || valueAsDouble > 9.223372036854776E18d)) {
            throwRangeException(val, columnIndex, -5);
        }
        return (long) valueAsDouble;
    }

    private long getLongWithOverflowCheck(int columnIndex, boolean doOverflowCheck) throws SQLException {
        long longValue = this.thisRow.getLong(columnIndex);
        if (doOverflowCheck) {
            checkForLongTruncation(columnIndex + 1, null, this.thisRow.getString(columnIndex, this.fields[columnIndex].getCharacterSet(), this.connection), longValue);
        }
        return longValue;
    }

    private long parseLongWithOverflowCheck(int columnIndex, byte[] valueAsBytes, String valueAsString, boolean doCheck) throws NumberFormatException, SQLException {
        long longValue;
        if (valueAsBytes == null && valueAsString == null) {
            return 0L;
        }
        if (valueAsBytes != null) {
            longValue = StringUtils.getLong(valueAsBytes);
        } else {
            valueAsString = valueAsString.trim();
            longValue = Long.parseLong(valueAsString);
        }
        if (doCheck && this.connection.getJdbcCompliantTruncationForReads()) {
            checkForLongTruncation(columnIndex, valueAsBytes, valueAsString, longValue);
        }
        return longValue;
    }

    private void checkForLongTruncation(int columnIndex, byte[] valueAsBytes, String valueAsString, long longValue) throws SQLException {
        if (longValue == Long.MIN_VALUE || longValue == Long.MAX_VALUE) {
            double valueAsDouble = Double.parseDouble(valueAsString == null ? new String(valueAsBytes) : valueAsString);
            if (valueAsDouble < -9.223372036854776E18d || valueAsDouble > 9.223372036854776E18d) {
                throwRangeException(valueAsString == null ? new String(valueAsBytes) : valueAsString, columnIndex, -5);
            }
        }
    }

    private short parseShortAsDouble(int columnIndex, String val) throws NumberFormatException, SQLException {
        if (val == null) {
            return (short) 0;
        }
        double valueAsDouble = Double.parseDouble(val);
        if (this.connection.getJdbcCompliantTruncationForReads() && (valueAsDouble < -32768.0d || valueAsDouble > 32767.0d)) {
            throwRangeException(String.valueOf(valueAsDouble), columnIndex, 5);
        }
        return (short) valueAsDouble;
    }

    private short parseShortWithOverflowCheck(int columnIndex, byte[] valueAsBytes, String valueAsString) throws NumberFormatException, SQLException {
        short shortValue;
        if (valueAsBytes == null && valueAsString == null) {
            return (short) 0;
        }
        if (valueAsBytes != null) {
            shortValue = StringUtils.getShort(valueAsBytes);
        } else {
            valueAsString = valueAsString.trim();
            shortValue = Short.parseShort(valueAsString);
        }
        if (this.connection.getJdbcCompliantTruncationForReads() && (shortValue == Short.MIN_VALUE || shortValue == Short.MAX_VALUE)) {
            long valueAsLong = Long.parseLong(valueAsString == null ? new String(valueAsBytes) : valueAsString);
            if (valueAsLong < -32768 || valueAsLong > 32767) {
                throwRangeException(valueAsString == null ? new String(valueAsBytes) : valueAsString, columnIndex, 5);
            }
        }
        return shortValue;
    }

    public boolean prev() throws SQLException {
        checkClosed();
        int rowIndex = this.rowData.getCurrentRowNumber();
        if (this.thisRow != null) {
            this.thisRow.closeOpenStreams();
        }
        if (rowIndex - 1 >= 0) {
            int rowIndex2 = rowIndex - 1;
            this.rowData.setCurrentRow(rowIndex2);
            this.thisRow = this.rowData.getAt(rowIndex2);
            return true;
        }
        if (rowIndex - 1 == -1) {
            this.rowData.setCurrentRow(rowIndex - 1);
            this.thisRow = null;
            return false;
        }
        return false;
    }

    @Override // java.sql.ResultSet
    public boolean previous() throws SQLException {
        if (this.onInsertRow) {
            this.onInsertRow = false;
        }
        if (this.doingUpdates) {
            this.doingUpdates = false;
        }
        return prev();
    }

    /*  JADX ERROR: JadxRuntimeException in pass: BlockProcessor
        jadx.core.utils.exceptions.JadxRuntimeException: Unreachable block: B:84:0x026b
        	at jadx.core.dex.visitors.blocks.BlockProcessor.checkForUnreachableBlocks(BlockProcessor.java:88)
        	at jadx.core.dex.visitors.blocks.BlockProcessor.processBlocksTree(BlockProcessor.java:52)
        	at jadx.core.dex.visitors.blocks.BlockProcessor.visit(BlockProcessor.java:44)
        */
    @Override // com.mysql.jdbc.ResultSetInternalMethods
    public void realClose(boolean r26) throws java.sql.SQLException {
        /*
            Method dump skipped, instructions count: 713
            To view this dump change 'Code comments level' option to 'DEBUG'
        */
        throw new UnsupportedOperationException("Method not decompiled: com.mysql.jdbc.ResultSetImpl.realClose(boolean):void");
    }

    @Override // com.mysql.jdbc.ResultSetInternalMethods
    public boolean reallyResult() {
        if (this.rowData != null) {
            return true;
        }
        return this.reallyResult;
    }

    @Override // java.sql.ResultSet
    public void refreshRow() throws SQLException {
        throw new NotUpdatable();
    }

    @Override // java.sql.ResultSet
    public boolean relative(int rows) throws SQLException {
        checkClosed();
        if (this.rowData.size() == 0) {
            return false;
        }
        if (this.thisRow != null) {
            this.thisRow.closeOpenStreams();
        }
        this.rowData.moveRowRelative(rows);
        this.thisRow = this.rowData.getAt(this.rowData.getCurrentRowNumber());
        return (this.rowData.isAfterLast() || this.rowData.isBeforeFirst()) ? false : true;
    }

    @Override // java.sql.ResultSet
    public boolean rowDeleted() throws SQLException {
        throw new NotImplemented();
    }

    @Override // java.sql.ResultSet
    public boolean rowInserted() throws SQLException {
        throw new NotImplemented();
    }

    @Override // java.sql.ResultSet
    public boolean rowUpdated() throws SQLException {
        throw new NotImplemented();
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public void setBinaryEncoded() {
        this.isBinaryEncoded = true;
    }

    private void setDefaultTimeZone(TimeZone defaultTimeZone) {
        this.defaultTimeZone = defaultTimeZone;
    }

    @Override // java.sql.ResultSet
    public void setFetchDirection(int direction) throws SQLException {
        if (direction != 1000 && direction != 1001 && direction != 1002) {
            throw SQLError.createSQLException(Messages.getString("ResultSet.Illegal_value_for_fetch_direction_64"), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
        this.fetchDirection = direction;
    }

    @Override // java.sql.ResultSet
    public void setFetchSize(int rows) throws SQLException {
        if (rows < 0) {
            throw SQLError.createSQLException(Messages.getString("ResultSet.Value_must_be_between_0_and_getMaxRows()_66"), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
        this.fetchSize = rows;
    }

    @Override // com.mysql.jdbc.ResultSetInternalMethods
    public void setFirstCharOfQuery(char c) {
        this.firstCharOfQuery = c;
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public void setNextResultSet(ResultSetInternalMethods nextResultSet) {
        this.nextResultSet = nextResultSet;
    }

    @Override // com.mysql.jdbc.ResultSetInternalMethods
    public void setOwningStatement(StatementImpl owningStatement) {
        this.owningStatement = owningStatement;
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public void setResultSetConcurrency(int concurrencyFlag) {
        this.resultSetConcurrency = concurrencyFlag;
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public void setResultSetType(int typeFlag) {
        this.resultSetType = typeFlag;
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public void setServerInfo(String info) {
        this.serverInfo = info;
    }

    @Override // com.mysql.jdbc.ResultSetInternalMethods
    public void setStatementUsedForFetchingRows(PreparedStatement stmt) {
        this.statementUsedForFetchingRows = stmt;
    }

    @Override // com.mysql.jdbc.ResultSetInternalMethods
    public void setWrapperStatement(java.sql.Statement wrapperStatement) {
        this.wrapperStatement = wrapperStatement;
    }

    private void throwRangeException(String valueAsString, int columnIndex, int jdbcType) throws SQLException {
        String datatype;
        switch (jdbcType) {
            case -6:
                datatype = "TINYINT";
                break;
            case -5:
                datatype = "BIGINT";
                break;
            case -4:
            case -3:
            case -2:
            case -1:
            case 0:
            case 1:
            case 2:
            default:
                datatype = new StringBuffer().append(" (JDBC type '").append(jdbcType).append("')").toString();
                break;
            case 3:
                datatype = "DECIMAL";
                break;
            case 4:
                datatype = "INTEGER";
                break;
            case 5:
                datatype = "SMALLINT";
                break;
            case 6:
                datatype = "FLOAT";
                break;
            case 7:
                datatype = "REAL";
                break;
            case 8:
                datatype = "DOUBLE";
                break;
        }
        throw SQLError.createSQLException(new StringBuffer().append("'").append(valueAsString).append("' in column '").append(columnIndex).append("' is outside valid range for the datatype ").append(datatype).append(".").toString(), SQLError.SQL_STATE_NUMERIC_VALUE_OUT_OF_RANGE);
    }

    public String toString() {
        if (this.reallyResult) {
            return super.toString();
        }
        return new StringBuffer().append("Result set representing update count of ").append(this.updateCount).toString();
    }

    @Override // java.sql.ResultSet
    public void updateArray(int arg0, Array arg1) throws SQLException {
        throw new NotImplemented();
    }

    @Override // java.sql.ResultSet
    public void updateArray(String arg0, Array arg1) throws SQLException {
        throw new NotImplemented();
    }

    @Override // java.sql.ResultSet
    public void updateAsciiStream(int columnIndex, InputStream x, int length) throws SQLException {
        throw new NotUpdatable();
    }

    @Override // java.sql.ResultSet
    public void updateAsciiStream(String columnName, InputStream x, int length) throws SQLException {
        updateAsciiStream(findColumn(columnName), x, length);
    }

    @Override // java.sql.ResultSet
    public void updateBigDecimal(int columnIndex, BigDecimal x) throws SQLException {
        throw new NotUpdatable();
    }

    @Override // java.sql.ResultSet
    public void updateBigDecimal(String columnName, BigDecimal x) throws SQLException {
        updateBigDecimal(findColumn(columnName), x);
    }

    @Override // java.sql.ResultSet
    public void updateBinaryStream(int columnIndex, InputStream x, int length) throws SQLException {
        throw new NotUpdatable();
    }

    @Override // java.sql.ResultSet
    public void updateBinaryStream(String columnName, InputStream x, int length) throws SQLException {
        updateBinaryStream(findColumn(columnName), x, length);
    }

    @Override // java.sql.ResultSet
    public void updateBlob(int arg0, java.sql.Blob arg1) throws SQLException {
        throw new NotUpdatable();
    }

    @Override // java.sql.ResultSet
    public void updateBlob(String arg0, java.sql.Blob arg1) throws SQLException {
        throw new NotUpdatable();
    }

    @Override // java.sql.ResultSet
    public void updateBoolean(int columnIndex, boolean x) throws SQLException {
        throw new NotUpdatable();
    }

    @Override // java.sql.ResultSet
    public void updateBoolean(String columnName, boolean x) throws SQLException {
        updateBoolean(findColumn(columnName), x);
    }

    @Override // java.sql.ResultSet
    public void updateByte(int columnIndex, byte x) throws SQLException {
        throw new NotUpdatable();
    }

    @Override // java.sql.ResultSet
    public void updateByte(String columnName, byte x) throws SQLException {
        updateByte(findColumn(columnName), x);
    }

    @Override // java.sql.ResultSet
    public void updateBytes(int columnIndex, byte[] x) throws SQLException {
        throw new NotUpdatable();
    }

    @Override // java.sql.ResultSet
    public void updateBytes(String columnName, byte[] x) throws SQLException {
        updateBytes(findColumn(columnName), x);
    }

    @Override // java.sql.ResultSet
    public void updateCharacterStream(int columnIndex, Reader x, int length) throws SQLException {
        throw new NotUpdatable();
    }

    @Override // java.sql.ResultSet
    public void updateCharacterStream(String columnName, Reader reader, int length) throws SQLException {
        updateCharacterStream(findColumn(columnName), reader, length);
    }

    @Override // java.sql.ResultSet
    public void updateClob(int arg0, java.sql.Clob arg1) throws SQLException {
        throw new NotImplemented();
    }

    @Override // java.sql.ResultSet
    public void updateClob(String columnName, java.sql.Clob clob) throws SQLException {
        updateClob(findColumn(columnName), clob);
    }

    @Override // java.sql.ResultSet
    public void updateDate(int columnIndex, Date x) throws SQLException {
        throw new NotUpdatable();
    }

    @Override // java.sql.ResultSet
    public void updateDate(String columnName, Date x) throws SQLException {
        updateDate(findColumn(columnName), x);
    }

    @Override // java.sql.ResultSet
    public void updateDouble(int columnIndex, double x) throws SQLException {
        throw new NotUpdatable();
    }

    @Override // java.sql.ResultSet
    public void updateDouble(String columnName, double x) throws SQLException {
        updateDouble(findColumn(columnName), x);
    }

    @Override // java.sql.ResultSet
    public void updateFloat(int columnIndex, float x) throws SQLException {
        throw new NotUpdatable();
    }

    @Override // java.sql.ResultSet
    public void updateFloat(String columnName, float x) throws SQLException {
        updateFloat(findColumn(columnName), x);
    }

    @Override // java.sql.ResultSet
    public void updateInt(int columnIndex, int x) throws SQLException {
        throw new NotUpdatable();
    }

    @Override // java.sql.ResultSet
    public void updateInt(String columnName, int x) throws SQLException {
        updateInt(findColumn(columnName), x);
    }

    @Override // java.sql.ResultSet
    public void updateLong(int columnIndex, long x) throws SQLException {
        throw new NotUpdatable();
    }

    @Override // java.sql.ResultSet
    public void updateLong(String columnName, long x) throws SQLException {
        updateLong(findColumn(columnName), x);
    }

    @Override // java.sql.ResultSet
    public void updateNull(int columnIndex) throws SQLException {
        throw new NotUpdatable();
    }

    @Override // java.sql.ResultSet
    public void updateNull(String columnName) throws SQLException {
        updateNull(findColumn(columnName));
    }

    @Override // java.sql.ResultSet
    public void updateObject(int columnIndex, Object x) throws SQLException {
        throw new NotUpdatable();
    }

    @Override // java.sql.ResultSet
    public void updateObject(int columnIndex, Object x, int scale) throws SQLException {
        throw new NotUpdatable();
    }

    @Override // java.sql.ResultSet
    public void updateObject(String columnName, Object x) throws SQLException {
        updateObject(findColumn(columnName), x);
    }

    @Override // java.sql.ResultSet
    public void updateObject(String columnName, Object x, int scale) throws SQLException {
        updateObject(findColumn(columnName), x);
    }

    @Override // java.sql.ResultSet
    public void updateRef(int arg0, Ref arg1) throws SQLException {
        throw new NotImplemented();
    }

    @Override // java.sql.ResultSet
    public void updateRef(String arg0, Ref arg1) throws SQLException {
        throw new NotImplemented();
    }

    @Override // java.sql.ResultSet
    public void updateRow() throws SQLException {
        throw new NotUpdatable();
    }

    @Override // java.sql.ResultSet
    public void updateShort(int columnIndex, short x) throws SQLException {
        throw new NotUpdatable();
    }

    @Override // java.sql.ResultSet
    public void updateShort(String columnName, short x) throws SQLException {
        updateShort(findColumn(columnName), x);
    }

    @Override // java.sql.ResultSet
    public void updateString(int columnIndex, String x) throws SQLException {
        throw new NotUpdatable();
    }

    @Override // java.sql.ResultSet
    public void updateString(String columnName, String x) throws SQLException {
        updateString(findColumn(columnName), x);
    }

    @Override // java.sql.ResultSet
    public void updateTime(int columnIndex, Time x) throws SQLException {
        throw new NotUpdatable();
    }

    @Override // java.sql.ResultSet
    public void updateTime(String columnName, Time x) throws SQLException {
        updateTime(findColumn(columnName), x);
    }

    @Override // java.sql.ResultSet
    public void updateTimestamp(int columnIndex, Timestamp x) throws SQLException {
        throw new NotUpdatable();
    }

    @Override // java.sql.ResultSet
    public void updateTimestamp(String columnName, Timestamp x) throws SQLException {
        updateTimestamp(findColumn(columnName), x);
    }

    @Override // java.sql.ResultSet
    public boolean wasNull() throws SQLException {
        return this.wasNullFlag;
    }

    protected Calendar getGmtCalendar() {
        if (this.gmtCalendar == null) {
            this.gmtCalendar = Calendar.getInstance(TimeZone.getTimeZone("GMT"));
        }
        return this.gmtCalendar;
    }
}
